/*! JointJS v2.2.0 (2018-10-30) - JavaScript diagramming library


This Source Code Form is subject to the terms of the Mozilla Public
License, v. 2.0. If a copy of the MPL was not distributed with this
file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/
(function(root, factory) {

    if (typeof define === 'function' && define.amd) {

        // AMD. Register as an anonymous module.
        define([], factory);

    } else if (typeof exports === 'object') {

        // Node. Does not work with strict CommonJS, but
        // only CommonJS-like environments that support module.exports,
        // like Node.
        module.exports = factory();

    } else {

        // Browser globals.
        root.g = factory();
    }

}(this, function() {

var g={};!function(o){var t=Math,R=t.abs,u=t.cos,a=t.sin,q=t.sqrt,z=t.min,j=t.max,c=t.atan2,e=t.round,r=t.floor,s=t.PI,h=t.random,E=t.pow;o.bezier={curveThroughPoints:function(t){return console.warn("deprecated"),new l(g.throughPoints(t)).serialize()},getCurveControlPoints:function(t){console.warn("deprecated");var n,e=[],i=[],r=t.length-1;if(1==r)return e[0]=new y((2*t[0].x+t[1].x)/3,(2*t[0].y+t[1].y)/3),i[0]=new y(2*e[0].x-t[0].x,2*e[0].y-t[0].y),[e,i];var s=[];for(n=1;n<r-1;n++)s[n]=4*t[n].x+2*t[n+1].x;s[0]=t[0].x+2*t[1].x,s[r-1]=(8*t[r-1].x+t[r].x)/2;var o=this.getFirstControlPoints(s);for(n=1;n<r-1;++n)s[n]=4*t[n].y+2*t[n+1].y;s[0]=t[0].y+2*t[1].y,s[r-1]=(8*t[r-1].y+t[r].y)/2;var h=this.getFirstControlPoints(s);for(n=0;n<r;n++)e.push(new y(o[n],h[n])),n<r-1?i.push(new y(2*t[n+1].x-o[n+1],2*t[n+1].y-h[n+1])):i.push(new y((t[r].x+o[r-1])/2,(t[r].y+h[r-1])/2));return[e,i]},getCurveDivider:function(t,n,e,i){console.warn("deprecated");var r=new g(t,n,e,i);return function(t){var n=r.divide(t);return[{p0:n[0].start,p1:n[0].controlPoint1,p2:n[0].controlPoint2,p3:n[0].end},{p0:n[1].start,p1:n[1].controlPoint1,p2:n[1].controlPoint2,p3:n[1].end}]}},getFirstControlPoints:function(t){console.warn("deprecated");var n=t.length,e=[],i=[],r=2;e[0]=t[0]/r;for(var s=1;s<n;s++)i[s]=1/r,r=(s<n-1?4:3.5)-i[s],e[s]=(t[s]-e[s-1])/r;for(s=1;s<n;s++)e[n-s-1]-=i[n-s]*e[n-s];return e},getInversionSolver:function(t,n,e,i){console.warn("deprecated");var r=new g(t,n,e,i);return function(t){return r.closestPointT(t)}}};var g=o.Curve=function(t,n,e,i){return this instanceof g?t instanceof g?new g(t.start,t.controlPoint1,t.controlPoint2,t.end):(this.start=new y(t),this.controlPoint1=new y(n),this.controlPoint2=new y(e),void(this.end=new y(i))):new g(t,n,e,i)};g.throughPoints=function(){function u(t){var n=t.length,e=[],i=[],r=2;e[0]=t[0]/r;for(var s=1;s<n;s++)i[s]=1/r,r=(s<n-1?4:3.5)-i[s],e[s]=(t[s]-e[s-1])/r;for(s=1;s<n;s++)e[n-s-1]-=i[n-s]*e[n-s];return e}return function(t){if(!t||Array.isArray(t)&&t.length<2)throw new Error("At least 2 points are required");for(var n=function(t){var n,e=[],i=[],r=t.length-1;if(1==r)return e[0]=new y((2*t[0].x+t[1].x)/3,(2*t[0].y+t[1].y)/3),i[0]=new y(2*e[0].x-t[0].x,2*e[0].y-t[0].y),[e,i];var s=[];for(n=1;n<r-1;n++)s[n]=4*t[n].x+2*t[n+1].x;s[0]=t[0].x+2*t[1].x,s[r-1]=(8*t[r-1].x+t[r].x)/2;var o=u(s);for(n=1;n<r-1;++n)s[n]=4*t[n].y+2*t[n+1].y;s[0]=t[0].y+2*t[1].y,s[r-1]=(8*t[r-1].y+t[r].y)/2;var h=u(s);for(n=0;n<r;n++)e.push(new y(o[n],h[n])),n<r-1?i.push(new y(2*t[n+1].x-o[n+1],2*t[n+1].y-h[n+1])):i.push(new y((t[r].x+o[r-1])/2,(t[r].y+h[r-1])/2));return[e,i]}(t),e=[],i=n[0].length,r=0;r<i;r++){var s=new y(n[0][r].x,n[0][r].y),o=new y(n[1][r].x,n[1][r].y);e.push(new g(t[r],s,o,t[r+1]))}return e}}(),g.prototype={bbox:function(){for(var t,n,e,i,r,s,o,h,u=this.start,a=this.controlPoint1,c=this.controlPoint2,l=this.end,f=u.x,g=u.y,p=a.x,d=a.y,v=c.x,y=c.y,w=l.x,m=l.y,x=new Array,b=new Array,S=[new Array,new Array],P=0;P<2;++P)if(e=0===P?(n=6*f-12*p+6*v,t=-3*f+9*p-9*v+3*w,3*p-3*f):(n=6*g-12*d+6*y,t=-3*g+9*d-9*y+3*m,3*d-3*g),R(t)<1e-12){if(R(n)<1e-12)continue;0<(i=-e/n)&&i<1&&b.push(i)}else h=q(o=n*n-4*e*t),o<0||(0<(r=(-n+h)/(2*t))&&r<1&&b.push(r),0<(s=(-n-h)/(2*t))&&s<1&&b.push(s));for(var A,L,E,T=b.length,I=T;T--;)L=(A=1-(i=b[T]))*A*A*f+3*A*A*i*p+3*A*i*i*v+i*i*i*w,S[0][T]=L,E=A*A*A*g+3*A*A*i*d+3*A*i*i*y+i*i*i*m,S[1][T]=E,x[T]={X:L,Y:E};b[I]=0,b[I+1]=1,x[I]={X:f,Y:g},x[I+1]={X:w,Y:m},S[0][I]=f,S[1][I]=g,S[0][I+1]=w,S[1][I+1]=m,b.length=I+2,S[0].length=I+2,S[1].length=I+2,x.length=I+2;var C=z.apply(null,S[0]),N=z.apply(null,S[1]),O=j.apply(null,S[0]),D=j.apply(null,S[1]);return new M(C,N,O-C,D-N)},clone:function(){return new g(this.start,this.controlPoint1,this.controlPoint2,this.end)},closestPoint:function(t,n){return this.pointAtT(this.closestPointT(t,n))},closestPointLength:function(t,n){var e=void 0===(n=n||{}).precision?this.PRECISION:n.precision,i={precision:e,subdivisions:void 0===n.subdivisions?this.getSubdivisions({precision:e}):n.subdivisions};return this.lengthAtT(this.closestPointT(t,i),i)},closestPointNormalizedLength:function(t,n){var e=void 0===(n=n||{}).precision?this.PRECISION:n.precision,i={precision:e,subdivisions:void 0===n.subdivisions?this.getSubdivisions({precision:e}):n.subdivisions},r=this.closestPointLength(t,i);if(!r)return 0;var s=this.length(i);return 0===s?0:r/s},closestPointT:function(t,n){for(var e,i,r,s,o,h,u=void 0===(n=n||{}).precision?this.PRECISION:n.precision,a=void 0===n.subdivisions?this.getSubdivisions({precision:u}):n.subdivisions,c=a.length,l=c?1/c:0,f=0;f<c;f++){var g=a[f],p=g.start.distance(t),d=g.end.distance(t),v=p+d;(!h||v<h)&&(e=g,i=f*l,r=(f+1)*l,s=p,o=d,h=v)}for(var y=E(10,-u);;){var w,m;if(w=s?R(s-o)/s:0,m=o?R(s-o)/o:0,w<y||m<y)return s<=o?i:r;var x=e.divide(.5);l/=2;var b=x[0].start.distance(t),S=x[0].end.distance(t),P=b+S,A=x[1].start.distance(t),L=x[1].end.distance(t);o=P<=A+L?(e=x[0],r-=l,s=b,S):(e=x[1],i+=l,s=A,L)}},closestPointTangent:function(t,n){return this.tangentAtT(this.closestPointT(t,n))},divide:function(t){var n=this.start,e=this.controlPoint1,i=this.controlPoint2,r=this.end;if(t<=0)return[new g(n,n,n,n),new g(n,e,i,r)];if(1<=t)return[new g(n,e,i,r),new g(r,r,r,r)];var s=this.getSkeletonPoints(t),o=s.startControlPoint1,h=s.startControlPoint2,u=s.divider,a=s.dividerControlPoint1,c=s.dividerControlPoint2;return[new g(n,o,h,u),new g(u,a,c,r)]},endpointDistance:function(){return this.start.distance(this.end)},equals:function(t){return!!t&&this.start.x===t.start.x&&this.start.y===t.start.y&&this.controlPoint1.x===t.controlPoint1.x&&this.controlPoint1.y===t.controlPoint1.y&&this.controlPoint2.x===t.controlPoint2.x&&this.controlPoint2.y===t.controlPoint2.y&&this.end.x===t.end.x&&this.end.y===t.end.y},getSkeletonPoints:function(t){var n=this.start,e=this.controlPoint1,i=this.controlPoint2,r=this.end;if(t<=0)return{startControlPoint1:n.clone(),startControlPoint2:n.clone(),divider:n.clone(),dividerControlPoint1:e.clone(),dividerControlPoint2:i.clone()};if(1<=t)return{startControlPoint1:e.clone(),startControlPoint2:i.clone(),divider:r.clone(),dividerControlPoint1:r.clone(),dividerControlPoint2:r.clone()};var s=new p(n,e).pointAt(t),o=new p(e,i).pointAt(t),h=new p(i,r).pointAt(t),u=new p(s,o).pointAt(t),a=new p(o,h).pointAt(t);return{startControlPoint1:s,startControlPoint2:u,divider:new p(u,a).pointAt(t),dividerControlPoint1:a,dividerControlPoint2:h}},getSubdivisions:function(t){var n=void 0===(t=t||{}).precision?this.PRECISION:t.precision,e=[new g(this.start,this.controlPoint1,this.controlPoint2,this.end)];if(0===n)return e;for(var i=this.endpointDistance(),r=E(10,-n),s=0;;){s+=1;for(var o=[],h=e.length,u=0;u<h;u++){var a=e[u].divide(.5);o.push(a[0],a[1])}for(var c=0,l=o.length,f=0;f<l;f++){c+=o[f].endpointDistance()}if(1<s&&(0!==c?(c-i)/c:0)<r)return o;e=o,i=c}},isDifferentiable:function(){var t=this.start,n=this.controlPoint1,e=this.controlPoint2,i=this.end;return!(t.equals(n)&&n.equals(e)&&e.equals(i))},length:function(t){for(var n=void 0===(t=t||{}).precision?this.PRECISION:t.precision,e=void 0===t.subdivisions?this.getSubdivisions({precision:n}):t.subdivisions,i=0,r=e.length,s=0;s<r;s++){i+=e[s].endpointDistance()}return i},lengthAtT:function(t,n){if(t<=0)return 0;var e=void 0===(n=n||{}).precision?this.PRECISION:n.precision;return this.divide(t)[0].length({precision:e})},pointAt:function(t,n){if(t<=0)return this.start.clone();if(1<=t)return this.end.clone();var e=this.tAt(t,n);return this.pointAtT(e)},pointAtLength:function(t,n){var e=this.tAtLength(t,n);return this.pointAtT(e)},pointAtT:function(t){return t<=0?this.start.clone():1<=t?this.end.clone():this.getSkeletonPoints(t).divider},PRECISION:3,scale:function(t,n,e){return this.start.scale(t,n,e),this.controlPoint1.scale(t,n,e),this.controlPoint2.scale(t,n,e),this.end.scale(t,n,e),this},tangentAt:function(t,n){if(!this.isDifferentiable())return null;t<0?t=0:1<t&&(t=1);var e=this.tAt(t,n);return this.tangentAtT(e)},tangentAtLength:function(t,n){if(!this.isDifferentiable())return null;var e=this.tAtLength(t,n);return this.tangentAtT(e)},tangentAtT:function(t){if(!this.isDifferentiable())return null;t<0?t=0:1<t&&(t=1);var n=this.getSkeletonPoints(t),e=n.startControlPoint2,i=n.dividerControlPoint1,r=n.divider,s=new p(e,i);return s.translate(r.x-e.x,r.y-e.y),s},tAt:function(t,n){if(t<=0)return 0;if(1<=t)return 1;var e=void 0===(n=n||{}).precision?this.PRECISION:n.precision,i={precision:e,subdivisions:void 0===n.subdivisions?this.getSubdivisions({precision:e}):n.subdivisions},r=this.length(i)*t;return this.tAtLength(r,i)},tAtLength:function(t,n){var e=!0;t<0&&(e=!1,t=-t);for(var i,r,s,o,h,u=void 0===(n=n||{}).precision?this.PRECISION:n.precision,a=void 0===n.subdivisions?this.getSubdivisions({precision:u}):n.subdivisions,c={precision:u,subdivisions:a},l=0,f=a.length,g=1/f,p=e?0:f-1;e?p<f:0<=p;e?p++:p--){var d=a[p],v=d.endpointDistance();if(t<=l+v){i=d,r=p*g,s=(p+1)*g,o=e?t-l:v+l-t,h=e?v+l-t:t-l;break}l+=v}if(!i)return e?1:0;for(var y=this.length(c),w=E(10,-u);;){var m,x;if((0!==y?o/y:0)<w)return r;if((0!==y?h/y:0)<w)return s;var b=i.divide(.5);g/=2;var S=b[0].endpointDistance(),P=b[1].endpointDistance();x=o<=S?(i=b[0],s-=g,S-(m=o)):(i=b[1],r+=g,P-(m=o-S)),o=m,h=x}},toPoints:function(t){for(var n=void 0===(t=t||{}).precision?this.PRECISION:t.precision,e=void 0===t.subdivisions?this.getSubdivisions({precision:n}):t.subdivisions,i=[e[0].start.clone()],r=e.length,s=0;s<r;s++){var o=e[s];i.push(o.end.clone())}return i},toPolyline:function(t){return new T(this.toPoints(t))},toString:function(){return this.start+" "+this.controlPoint1+" "+this.controlPoint2+" "+this.end},translate:function(t,n){return this.start.translate(t,n),this.controlPoint1.translate(t,n),this.controlPoint2.translate(t,n),this.end.translate(t,n),this}};var i=o.Ellipse=function(t,n,e){return this instanceof i?t instanceof i?new i(new y(t.x,t.y),t.a,t.b):(t=new y(t),this.x=t.x,this.y=t.y,this.a=n,void(this.b=e)):new i(t,n,e)};i.fromRect=function(t){return t=new M(t),new i(t.center(),t.width/2,t.height/2)},i.prototype={bbox:function(){return new M(this.x-this.a,this.y-this.b,2*this.a,2*this.b)},center:function(){return new y(this.x,this.y)},clone:function(){return new i(this)},containsPoint:function(t){return this.normalizedDistance(t)<=1},equals:function(t){return!!t&&t.x===this.x&&t.y===this.y&&t.a===this.a&&t.b===this.b},inflate:function(t,n){return void 0===t&&(t=0),void 0===n&&(n=t),this.a+=2*t,this.b+=2*n,this},intersectionWithLine:function(t){var n=[],e=t.start,i=t.end,r=this.a,s=this.b,o=t.vector(),h=e.difference(new y(this)),u=new y(o.x/(r*r),o.y/(s*s)),a=new y(h.x/(r*r),h.y/(s*s)),c=o.dot(u),l=o.dot(a),f=l*l-c*(h.dot(a)-1);if(f<0)return null;if(0<f){var g=q(f),p=(-l-g)/c,d=(-l+g)/c;if((p<0||1<p)&&(d<0||1<d))return null;0<=p&&p<=1&&n.push(e.lerp(i,p)),0<=d&&d<=1&&n.push(e.lerp(i,d))}else{var v=-l/c;if(!(0<=v&&v<=1))return null;n.push(e.lerp(i,v))}return n},intersectionWithLineFromCenterToPoint:function(t,n){t=new y(t),n&&t.rotate(new y(this.x,this.y),n);var e,i=t.x-this.x,r=t.y-this.y;if(0===i)return e=this.bbox().pointNearestToPoint(t),n?e.rotate(new y(this.x,this.y),-n):e;var s=r/i,o=s*s,h=this.a*this.a,u=this.b*this.b,a=q(1/(1/h+o/u)),c=s*(a=i<0?-a:a);return e=new y(this.x+a,this.y+c),n?e.rotate(new y(this.x,this.y),-n):e},normalizedDistance:function(t){var n=t.x,e=t.y,i=this.a,r=this.b,s=this.x,o=this.y;return(n-s)*(n-s)/(i*i)+(e-o)*(e-o)/(r*r)},tangentTheta:function(t){var n,e,i=t.x,r=t.y,s=this.a,o=this.b,h=this.bbox().center(),u=h.x,a=h.y,c=i>h.x+s/2,l=i<h.x-s/2;return c||l?e=s*s/(i-u)-s*s*(r-a)*((n=i>h.x?r-30:r+30)-a)/(o*o*(i-u))+u:n=o*o/(r-a)-o*o*(i-u)*((e=r>h.y?i+30:i-30)-u)/(s*s*(r-a))+a,new y(e,n).theta(t)},toString:function(){return new y(this.x,this.y).toString()+" "+this.a+" "+this.b}};var p=o.Line=function(t,n){return this instanceof p?t instanceof p?new p(t.start,t.end):(this.start=new y(t),void(this.end=new y(n))):new p(t,n)};p.prototype={bbox:function(){var t=z(this.start.x,this.end.x),n=z(this.start.y,this.end.y),e=j(this.start.x,this.end.x),i=j(this.start.y,this.end.y);return new M(t,n,e-t,i-n)},bearing:function(){var t=w(this.start.y),n=w(this.end.y),e=this.start.x,i=this.end.x,r=w(i-e),s=a(r)*u(n),o=u(t)*a(n)-a(t)*u(n)*u(r),h=v(c(s,o))-22.5;return h<0&&(h+=360),["NE","E","SE","S","SW","W","NW","N"][h=parseInt(h/45)]},clone:function(){return new p(this.start,this.end)},closestPoint:function(t){return this.pointAt(this.closestPointNormalizedLength(t))},closestPointLength:function(t){return this.closestPointNormalizedLength(t)*this.length()},closestPointNormalizedLength:function(t){var n=this.vector().dot(new p(this.start,t).vector()),e=z(1,j(0,n/this.squaredLength()));return e!=e?0:e},closestPointTangent:function(t){return this.tangentAt(this.closestPointNormalizedLength(t))},equals:function(t){return!!t&&this.start.x===t.start.x&&this.start.y===t.start.y&&this.end.x===t.end.x&&this.end.y===t.end.y},intersect:function(t,n){if(t instanceof p||t instanceof M||t instanceof T||t instanceof i||t instanceof l){var e=t.intersectionWithLine(this,n);return e&&t instanceof p&&(e=e[0]),e}return null},intersectionWithLine:function(t){var n=new y(this.end.x-this.start.x,this.end.y-this.start.y),e=new y(t.end.x-t.start.x,t.end.y-t.start.y),i=n.x*e.y-n.y*e.x,r=new y(t.start.x-this.start.x,t.start.y-this.start.y),s=r.x*e.y-r.y*e.x,o=r.x*n.y-r.y*n.x;if(0===i||s*i<0||o*i<0)return null;if(0<i){if(i<s||i<o)return null}else if(s<i||o<i)return null;return[new y(this.start.x+s*n.x/i,this.start.y+s*n.y/i)]},isDifferentiable:function(){return!this.start.equals(this.end)},length:function(){return q(this.squaredLength())},midpoint:function(){return new y((this.start.x+this.end.x)/2,(this.start.y+this.end.y)/2)},pointAt:function(t){var n=this.start,e=this.end;return t<=0?n.clone():1<=t?e.clone():n.lerp(e,t)},pointAtLength:function(t){var n=this.start,e=this.end,i=!0;t<0&&(i=!1,t=-t);var r=this.length();return r<=t?i?e.clone():n.clone():this.pointAt((i?t:r-t)/r)},pointOffset:function(t){t=new o.Point(t);var n=this.start,e=this.end;return((e.x-n.x)*(t.y-n.y)-(e.y-n.y)*(t.x-n.x))/this.length()},rotate:function(t,n){return this.start.rotate(t,n),this.end.rotate(t,n),this},round:function(t){var n=E(10,t||0);return this.start.x=e(this.start.x*n)/n,this.start.y=e(this.start.y*n)/n,this.end.x=e(this.end.x*n)/n,this.end.y=e(this.end.y*n)/n,this},scale:function(t,n,e){return this.start.scale(t,n,e),this.end.scale(t,n,e),this},setLength:function(t){var n=this.length();if(!n)return this;var e=t/n;return this.scale(e,e,this.start)},squaredLength:function(){var t=this.start.x,n=this.start.y;return(t-=this.end.x)*t+(n-=this.end.y)*n},tangentAt:function(t){if(!this.isDifferentiable())return null;var n=this.start,e=this.end,i=this.pointAt(t),r=new p(n,e);return r.translate(i.x-n.x,i.y-n.y),r},tangentAtLength:function(t){if(!this.isDifferentiable())return null;var n=this.start,e=this.end,i=this.pointAtLength(t),r=new p(n,e);return r.translate(i.x-n.x,i.y-n.y),r},toString:function(){return this.start.toString()+" "+this.end.toString()},translate:function(t,n){return this.start.translate(t,n),this.end.translate(t,n),this},vector:function(){return new y(this.end.x-this.start.x,this.end.y-this.start.y)}},p.prototype.intersection=p.prototype.intersect;var l=o.Path=function(t){if(!(this instanceof l))return new l(t);if("string"==typeof t)return new l.parse(t);var n,e;if(this.segments=[],t){if(Array.isArray(t)&&0!==t.length)if(e=t.length,t[0].isSegment)for(n=0;n<e;n++){var i=t[n];this.appendSegment(i)}else{var r=null;for(n=0;n<e;n++){var s=t[n];if(!(s instanceof p||s instanceof g))throw new Error("Cannot construct a path segment from the provided object.");0===n&&this.appendSegment(l.createSegment("M",s.start)),r&&!r.end.equals(s.start)&&this.appendSegment(l.createSegment("M",s.start)),s instanceof p?this.appendSegment(l.createSegment("L",s.end)):s instanceof g&&this.appendSegment(l.createSegment("C",s.controlPoint1,s.controlPoint2,s.end)),r=s}}else if(t.isSegment)this.appendSegment(t);else if(t instanceof p)this.appendSegment(l.createSegment("M",t.start)),this.appendSegment(l.createSegment("L",t.end));else if(t instanceof g)this.appendSegment(l.createSegment("M",t.start)),this.appendSegment(l.createSegment("C",t.controlPoint1,t.controlPoint2,t.end));else if(t instanceof T&&t.points&&0!==t.points.length)for(e=t.points.length,n=0;n<e;n++){var o=t.points[n];0===n?this.appendSegment(l.createSegment("M",o)):this.appendSegment(l.createSegment("L",o))}}else;};l.parse=function(t){if(!t)return new l;for(var n=new l,e=t.match(/(?:[a-zA-Z] *)(?:(?:-?\d+(?:\.\d+)? *,? *)|(?:-?\.\d+ *,? *))+|(?:[a-zA-Z] *)(?! |\d|-|\.)/g),i=e.length,r=0;r<i;r++){var s=e[r].match(/(?:[a-zA-Z])|(?:(?:-?\d+(?:\.\d+)?))|(?:(?:-?\.\d+))/g),o=l.createSegment.apply(this,s);n.appendSegment(o)}return n},l.createSegment=function(t){if(!t)throw new Error("Type must be provided.");var n=l.segmentTypes[t];if(!n)throw new Error(t+" is not a recognized path segment type.");for(var e=[],i=arguments.length,r=1;r<i;r++)e.push(arguments[r]);return m(n,e)},l.prototype={appendSegment:function(t){var n,e=this.segments,i=e.length,r=0!==i?e[i-1]:null;if(Array.isArray(t)){if(!t[0].isSegment)throw new Error("Segments required.");for(var s=t.length,o=0;o<s;o++){var h=t[o];n=this.prepareSegment(h,r,null),e.push(n),r=n}}else{if(!t||!t.isSegment)throw new Error("Segment required.");n=this.prepareSegment(t,r,null),e.push(n)}},bbox:function(){var t,n=this.segments,e=n.length;if(0===e)return null;for(var i=0;i<e;i++){var r=n[i];if(r.isVisible){var s=r.bbox();t=t?t.union(s):s}}if(t)return t;var o=n[e-1];return new M(o.end.x,o.end.y,0,0)},clone:function(){for(var t=this.segments,n=t.length,e=new l,i=0;i<n;i++){var r=t[i].clone();e.appendSegment(r)}return e},closestPoint:function(t,n){var e=this.closestPointT(t,n);return e?this.pointAtT(e):null},closestPointLength:function(t,n){var e=void 0===(n=n||{}).precision?this.PRECISION:n.precision,i={precision:e,segmentSubdivisions:void 0===n.segmentSubdivisions?this.getSegmentSubdivisions({precision:e}):n.segmentSubdivisions},r=this.closestPointT(t,i);return r?this.lengthAtT(r,i):0},closestPointNormalizedLength:function(t,n){var e=void 0===(n=n||{}).precision?this.PRECISION:n.precision,i={precision:e,segmentSubdivisions:void 0===n.segmentSubdivisions?this.getSegmentSubdivisions({precision:e}):n.segmentSubdivisions},r=this.closestPointLength(t,i);if(0===r)return 0;var s=this.length(i);return 0===s?0:r/s},closestPointT:function(t,n){var e=this.segments,i=e.length;if(0===i)return null;for(var r,s=void 0===(n=n||{}).precision?this.PRECISION:n.precision,o=void 0===n.segmentSubdivisions?this.getSegmentSubdivisions({precision:s}):n.segmentSubdivisions,h=1/0,u=0;u<i;u++){var a=e[u],c=o[u];if(a.isVisible){var l=a.closestPointT(t,{precision:s,subdivisions:c}),f=a.pointAtT(l),g=new p(f,t).squaredLength();g<h&&(r={segmentIndex:u,value:l},h=g)}}return r||{segmentIndex:i-1,value:1}},closestPointTangent:function(t,n){var e=this.segments,i=e.length;if(0===i)return null;for(var r,s=void 0===(n=n||{}).precision?this.PRECISION:n.precision,o=void 0===n.segmentSubdivisions?this.getSegmentSubdivisions({precision:s}):n.segmentSubdivisions,h=1/0,u=0;u<i;u++){var a=e[u],c=o[u];if(a.isDifferentiable()){var l=a.closestPointT(t,{precision:s,subdivisions:c}),f=a.pointAtT(l),g=new p(f,t).squaredLength();g<h&&(r=a.tangentAtT(l),h=g)}}return r||null},equals:function(t){if(!t)return!1;var n=this.segments,e=t.segments,i=n.length;if(e.length!==i)return!1;for(var r=0;r<i;r++){var s=n[r],o=e[r];if(s.type!==o.type||!s.equals(o))return!1}return!0},getSegment:function(t){var n=this.segments,e=n.length;if(0===e)throw new Error("Path has no segments.");if(t<0&&(t=e+t),e<=t||t<0)throw new Error("Index out of range.");return n[t]},getSegmentSubdivisions:function(t){for(var n=this.segments,e=n.length,i=void 0===(t=t||{}).precision?this.PRECISION:t.precision,r=[],s=0;s<e;s++){var o=n[s].getSubdivisions({precision:i});r.push(o)}return r},insertSegment:function(t,n){var e,i=this.segments,r=i.length;if(t<0&&(t=r+t+1),r<t||t<0)throw new Error("Index out of range.");var s=null,o=null;if(0!==r&&(o=1<=t?(s=i[t-1]).nextSegment:i[0]),Array.isArray(n)){if(!n[0].isSegment)throw new Error("Segments required.");for(var h=n.length,u=0;u<h;u++){var a=n[u];e=this.prepareSegment(a,s,o),i.splice(t+u,0,e),s=e}}else{if(!n||!n.isSegment)throw new Error("Segment required.");e=this.prepareSegment(n,s,o),i.splice(t,0,e)}},intersectionWithLine:function(t,n){var e=null,i=this.toPolylines(n);if(!i)return null;for(var r=0,s=i.length;r<s;r++){var o=i[r],h=t.intersect(o);h&&(e||(e=[]),Array.isArray(h)?Array.prototype.push.apply(e,h):e.push(h))}return e},isDifferentiable:function(){for(var t=this.segments,n=t.length,e=0;e<n;e++){if(t[e].isDifferentiable())return!0}return!1},isValid:function(){var t=this.segments;return 0===t.length||"M"===t[0].type},length:function(t){var n=this.segments,e=n.length;if(0===e)return 0;for(var i=void 0===(t=t||{}).precision?this.PRECISION:t.precision,r=void 0===t.segmentSubdivisions?this.getSegmentSubdivisions({precision:i}):t.segmentSubdivisions,s=0,o=0;o<e;o++){var h=n[o],u=r[o];s+=h.length({subdivisions:u})}return s},lengthAtT:function(t,n){var e=this.segments,i=e.length;if(0===i)return 0;var r=t.segmentIndex;if(r<0)return 0;var s=t.value;i<=r?(r=i-1,s=1):s<0?s=0:1<s&&(s=1);for(var o,h=void 0===(n=n||{}).precision?this.PRECISION:n.precision,u=void 0===n.segmentSubdivisions?this.getSegmentSubdivisions({precision:h}):n.segmentSubdivisions,a=0,c=0;c<r;c++){var l=e[c];o=u[c],a+=l.length({precisison:h,subdivisions:o})}return l=e[r],o=u[r],a+=l.lengthAtT(s,{precisison:h,subdivisions:o})},pointAt:function(t,n){if(0===this.segments.length)return null;if(t<=0)return this.start.clone();if(1<=t)return this.end.clone();var e=void 0===(n=n||{}).precision?this.PRECISION:n.precision,i={precision:e,segmentSubdivisions:void 0===n.segmentSubdivisions?this.getSegmentSubdivisions({precision:e}):n.segmentSubdivisions},r=this.length(i)*t;return this.pointAtLength(r,i)},pointAtLength:function(t,n){var e=this.segments,i=e.length;if(0===i)return null;if(0===t)return this.start.clone();var r=!0;t<0&&(r=!1,t=-t);for(var s,o=void 0===(n=n||{}).precision?this.PRECISION:n.precision,h=void 0===n.segmentSubdivisions?this.getSegmentSubdivisions({precision:o}):n.segmentSubdivisions,u=0,a=r?0:i-1;r?a<i:0<=a;r?a++:a--){var c=e[a],l=h[a],f=c.length({precision:o,subdivisions:l});if(c.isVisible){if(t<=u+f)return c.pointAtLength((r?1:-1)*(t-u),{precision:o,subdivisions:l});s=c}u+=f}return s?r?s.end:s.start:e[i-1].end.clone()},pointAtT:function(t){var n=this.segments,e=n.length;if(0===e)return null;var i=t.segmentIndex;if(i<0)return n[0].pointAtT(0);if(e<=i)return n[e-1].pointAtT(1);var r=t.value;return r<0?r=0:1<r&&(r=1),n[i].pointAtT(r)},PRECISION:3,prepareSegment:function(t,n,e){t.previousSegment=n,t.nextSegment=e,n&&(n.nextSegment=t),e&&(e.previousSegment=t);var i=t;return t.isSubpathStart&&(t.subpathStartSegment=t,i=e),i&&this.updateSubpathStartSegment(i),t},removeSegment:function(t){var n=this.segments,e=n.length;if(0===e)throw new Error("Path has no segments.");if(t<0&&(t=e+t),e<=t||t<0)throw new Error("Index out of range.");var i=n.splice(t,1)[0],r=i.previousSegment,s=i.nextSegment;r&&(r.nextSegment=s),s&&(s.previousSegment=r),i.isSubpathStart&&s&&this.updateSubpathStartSegment(s)},replaceSegment:function(t,n){var e,i=this.segments,r=i.length;if(0===r)throw new Error("Path has no segments.");if(t<0&&(t=r+t),r<=t||t<0)throw new Error("Index out of range.");var s=i[t],o=s.previousSegment,h=s.nextSegment,u=s.isSubpathStart;if(Array.isArray(n)){if(!n[0].isSegment)throw new Error("Segments required.");i.splice(t,1);for(var a=n.length,c=0;c<a;c++){var l=n[c];e=this.prepareSegment(l,o,h),i.splice(t+c,0,e),o=e,u&&e.isSubpathStart&&(u=!1)}}else{if(!n||!n.isSegment)throw new Error("Segment required.");e=this.prepareSegment(n,o,h),i.splice(t,1,e),u&&e.isSubpathStart&&(u=!1)}u&&h&&this.updateSubpathStartSegment(h)},scale:function(t,n,e){for(var i=this.segments,r=i.length,s=0;s<r;s++){i[s].scale(t,n,e)}return this},segmentAt:function(t,n){var e=this.segmentIndexAt(t,n);return e?this.getSegment(e):null},segmentAtLength:function(t,n){var e=this.segmentIndexAtLength(t,n);return e?this.getSegment(e):null},segmentIndexAt:function(t,n){if(0===this.segments.length)return null;t<0&&(t=0),1<t&&(t=1);var e=void 0===(n=n||{}).precision?this.PRECISION:n.precision,i={precision:e,segmentSubdivisions:void 0===n.segmentSubdivisions?this.getSegmentSubdivisions({precision:e}):n.segmentSubdivisions},r=this.length(i)*t;return this.segmentIndexAtLength(r,i)},segmentIndexAtLength:function(t,n){var e=this.segments,i=e.length;if(0===i)return null;var r=!0;t<0&&(r=!1,t=-t);for(var s=void 0===(n=n||{}).precision?this.PRECISION:n.precision,o=void 0===n.segmentSubdivisions?this.getSegmentSubdivisions({precision:s}):n.segmentSubdivisions,h=null,u=0,a=r?0:i-1;r?a<i:0<=a;r?a++:a--){var c=e[a],l=o[a],f=c.length({precision:s,subdivisions:l});if(c.isVisible){if(t<=u+f)return a;h=a}u+=f}return h},serialize:function(){if(!this.isValid())throw new Error("Invalid path segments.");return this.toString()},tangentAt:function(t,n){if(0===this.segments.length)return null;t<0&&(t=0),1<t&&(t=1);var e=void 0===(n=n||{}).precision?this.PRECISION:n.precision,i={precision:e,segmentSubdivisions:void 0===n.segmentSubdivisions?this.getSegmentSubdivisions({precision:e}):n.segmentSubdivisions},r=this.length(i)*t;return this.tangentAtLength(r,i)},tangentAtLength:function(t,n){var e=this.segments,i=e.length;if(0===i)return null;var r=!0;t<0&&(r=!1,t=-t);for(var s,o=void 0===(n=n||{}).precision?this.PRECISION:n.precision,h=void 0===n.segmentSubdivisions?this.getSegmentSubdivisions({precision:o}):n.segmentSubdivisions,u=0,a=r?0:i-1;r?a<i:0<=a;r?a++:a--){var c=e[a],l=h[a],f=c.length({precision:o,subdivisions:l});if(c.isDifferentiable()){if(t<=u+f)return c.tangentAtLength((r?1:-1)*(t-u),{precision:o,subdivisions:l});s=c}u+=f}if(s){var g=r?1:0;return s.tangentAtT(g)}return null},tangentAtT:function(t){var n=this.segments,e=n.length;if(0===e)return null;var i=t.segmentIndex;if(i<0)return n[0].tangentAtT(0);if(e<=i)return n[e-1].tangentAtT(1);var r=t.value;return r<0?r=0:1<r&&(r=1),n[i].tangentAtT(r)},toPoints:function(t){var n=this.segments,e=n.length;if(0===e)return null;for(var i=void 0===(t=t||{}).precision?this.PRECISION:t.precision,r=void 0===t.segmentSubdivisions?this.getSegmentSubdivisions({precision:i}):t.segmentSubdivisions,s=[],o=[],h=0;h<e;h++){var u=n[h];if(u.isVisible){var a=r[h];if(0<a.length){var c=a.map(function(t){return t.start});Array.prototype.push.apply(o,c)}else o.push(u.start)}else 0<o.length&&(o.push(n[h-1].end),s.push(o),o=[])}return 0<o.length&&(o.push(this.end),s.push(o)),s},toPolylines:function(t){var n=[],e=this.toPoints(t);if(!e)return null;for(var i=0,r=e.length;i<r;i++)n.push(new T(e[i]));return n},toString:function(){for(var t=this.segments,n=t.length,e="",i=0;i<n;i++){e+=t[i].serialize()+" "}return e.trim()},translate:function(t,n){for(var e=this.segments,i=e.length,r=0;r<i;r++){e[r].translate(t,n)}return this},updateSubpathStartSegment:function(t){for(var n=t.previousSegment;t&&!t.isSubpathStart;)t.subpathStartSegment=n?n.subpathStartSegment:null,t=(n=t).nextSegment}},Object.defineProperty(l.prototype,"start",{configurable:!0,enumerable:!0,get:function(){var t=this.segments,n=t.length;if(0===n)return null;for(var e=0;e<n;e++){var i=t[e];if(i.isVisible)return i.start}return t[n-1].end}}),Object.defineProperty(l.prototype,"end",{configurable:!0,enumerable:!0,get:function(){var t=this.segments,n=t.length;if(0===n)return null;for(var e=n-1;0<=e;e--){var i=t[e];if(i.isVisible)return i.end}return t[n-1].end}});var y=o.Point=function(t,n){if(!(this instanceof y))return new y(t,n);if("string"==typeof t){var e=t.split(-1===t.indexOf("@")?" ":"@");t=parseFloat(e[0]),n=parseFloat(e[1])}else Object(t)===t&&(n=t.y,t=t.x);this.x=void 0===t?0:t,this.y=void 0===n?0:n};y.fromPolar=function(t,n,e){e=e&&new y(e)||new y(0,0);var i=R(t*u(n)),r=R(t*a(n)),s=f(v(n));return s<90?r=-r:s<180?(i=-i,r=-r):s<270&&(i=-i),new y(e.x+i,e.y+r)},y.random=function(t,n,e,i){return new y(r(h()*(n-t+1)+t),r(h()*(i-e+1)+e))},y.prototype={adhereToRect:function(t){return t.containsPoint(this)||(this.x=z(j(this.x,t.x),t.x+t.width),this.y=z(j(this.y,t.y),t.y+t.height)),this},angleBetween:function(t,n){var e=this.equals(t)||this.equals(n)?NaN:this.theta(n)-this.theta(t);return e<0&&(e+=360),e},bearing:function(t){return new p(this,t).bearing()},changeInAngle:function(t,n,e){return this.clone().offset(-t,-n).theta(e)-this.theta(e)},clone:function(){return new y(this)},cross:function(t,n){return t&&n?(n.x-this.x)*(t.y-this.y)-(n.y-this.y)*(t.x-this.x):NaN},difference:function(t,n){return Object(t)===t&&(n=t.y,t=t.x),new y(this.x-(t||0),this.y-(n||0))},distance:function(t){return new p(this,t).length()},dot:function(t){return t?this.x*t.x+this.y*t.y:NaN},equals:function(t){return!!t&&this.x===t.x&&this.y===t.y},lerp:function(t,n){var e=this.x,i=this.y;return new y((1-n)*e+n*t.x,(1-n)*i+n*t.y)},magnitude:function(){return q(this.x*this.x+this.y*this.y)||.01},manhattanDistance:function(t){return R(t.x-this.x)+R(t.y-this.y)},move:function(t,n){var e=w(new y(t).theta(this));return this.offset(u(e)*n,-a(e)*n)},normalize:function(t){var n=(t||1)/this.magnitude();return this.scale(n,n)},offset:function(t,n){return Object(t)===t&&(n=t.y,t=t.x),this.x+=t||0,this.y+=n||0,this},reflection:function(t){return new y(t).move(this,this.distance(t))},rotate:function(t,n){t=t||new o.Point(0,0),n=w(f(-n));var e=u(n),i=a(n),r=e*(this.x-t.x)-i*(this.y-t.y)+t.x,s=i*(this.x-t.x)+e*(this.y-t.y)+t.y;return this.x=r,this.y=s,this},round:function(t){var n=E(10,t||0);return this.x=e(this.x*n)/n,this.y=e(this.y*n)/n,this},scale:function(t,n,e){return e=e&&new y(e)||new y(0,0),this.x=e.x+t*(this.x-e.x),this.y=e.y+n*(this.y-e.y),this},snapToGrid:function(t,n){return this.x=d(this.x,t),this.y=d(this.y,n||t),this},squaredDistance:function(t){return new p(this,t).squaredLength()},theta:function(t){var n=-((t=new y(t)).y-this.y),e=t.x-this.x,i=c(n,e);return i<0&&(i=2*s+i),180*i/s},toJSON:function(){return{x:this.x,y:this.y}},toPolar:function(t){t=t&&new y(t)||new y(0,0);var n=this.x,e=this.y;return this.x=q((n-t.x)*(n-t.x)+(e-t.y)*(e-t.y)),this.y=w(t.theta(new y(n,e))),this},toString:function(){return this.x+"@"+this.y},update:function(t,n){return this.x=t||0,this.y=n||0,this},vectorAngle:function(t){return new y(0,0).angleBetween(this,t)}},y.prototype.translate=y.prototype.offset;var T=o.Polyline=function(t){return this instanceof T?"string"==typeof t?new T.parse(t):void(this.points=Array.isArray(t)?t.map(y):[]):new T(t)};T.parse=function(t){if(""===(t=t.trim()))return new T;for(var n=[],e=t.split(/\s*,\s*|\s+/),i=e.length,r=0;r<i;r+=2)n.push({x:+e[r],y:+e[r+1]});return new T(n)},T.prototype={bbox:function(){var t=1/0,n=-1/0,e=1/0,i=-1/0,r=this.points,s=r.length;if(0===s)return null;for(var o=0;o<s;o++){var h=r[o],u=h.x,a=h.y;u<t&&(t=u),n<u&&(n=u),a<e&&(e=a),i<a&&(i=a)}return new M(t,e,n-t,i-e)},clone:function(){var t=this.points,n=t.length;if(0===n)return new T;for(var e=[],i=0;i<n;i++){var r=t[i].clone();e.push(r)}return new T(e)},closestPoint:function(t){var n=this.closestPointLength(t);return this.pointAtLength(n)},closestPointLength:function(t){var n,e=this.points,i=e.length;if(0===i)return 0;if(1===i)return 0;for(var r=1/0,s=0,o=i-1,h=0;h<o;h++){var u=new p(e[h],e[h+1]),a=u.length(),c=u.closestPointNormalizedLength(t),l=u.pointAt(c).squaredDistance(t);l<r&&(r=l,n=s+c*a),s+=a}return n},closestPointNormalizedLength:function(t){var n=this.closestPointLength(t);if(0===n)return 0;var e=this.length();return 0===e?0:n/e},closestPointTangent:function(t){var n=this.closestPointLength(t);return this.tangentAtLength(n)},convexHull:function(){var t,n,e,i=this.points,r=i.length;if(0===r)return new T;for(t=0;t<r;t++)void 0===e?e=i[t]:i[t].y<e.y?e=i[t]:i[t].y===e.y&&i[t].x>e.x&&(e=i[t]);var s=[];for(t=0;t<r;t++){var o=e.theta(i[t]);0===o&&(o=360);var h=[i[t],t,o];s.push(h)}if(s.sort(function(t,n){var e=t[2]-n[2];return 0===e&&(e=n[1]-t[1]),e}),2<s.length){var u=s[s.length-1];s.unshift(u)}for(var a,c,l,f,g,p,d,v={},y=[];0!==s.length;)if(c=(a=s.pop())[0],!v.hasOwnProperty(a[0]+"@@"+a[1]))for(var w=!1;!w;)if(y.length<2)y.push(a),w=!0;else{f=(l=y.pop())[0];var m=(p=(g=y.pop())[0]).cross(f,c);if(m<0)y.push(g),y.push(l),y.push(a),w=!0;else if(0===m){var x=f.angleBetween(p,c);R(x-180)<1e-10?(v[l[0]+"@@"+l[1]]=f,y.push(g)):f.equals(c)||p.equals(f)?(v[l[0]+"@@"+l[1]]=f,y.push(g)):R((x+1)%360-1)<1e-10&&(y.push(g),s.push(l))}else v[l[0]+"@@"+l[1]]=f,y.push(g)}2<y.length&&y.pop();var b=-1;for(n=y.length,t=0;t<n;t++){var S=y[t][1];(void 0===d||S<d)&&(d=S,b=t)}var P=[];if(0<b){var A=y.slice(b),L=y.slice(0,b);P=A.concat(L)}else P=y;var E=[];for(n=P.length,t=0;t<n;t++)E.push(P[t][0]);return new T(E)},equals:function(t){if(!t)return!1;var n=this.points,e=t.points,i=n.length;if(e.length!==i)return!1;for(var r=0;r<i;r++){var s=n[r],o=t.points[r];if(!s.equals(o))return!1}return!0},intersectionWithLine:function(t){for(var n=new p(t),e=[],i=this.points,r=0,s=i.length-1;r<s;r++){var o=i[r],h=i[r+1],u=new p(o,h),a=n.intersectionWithLine(u);a&&e.push(a[0])}return 0<e.length?e:null},isDifferentiable:function(){var t=this.points,n=t.length;if(0===n)return!1;for(var e=n-1,i=0;i<e;i++){var r=t[i],s=t[i+1];if(new p(r,s).isDifferentiable())return!0}return!1},length:function(){var t=this.points,n=t.length;if(0===n)return 0;for(var e=0,i=n-1,r=0;r<i;r++)e+=t[r].distance(t[r+1]);return e},pointAt:function(t){var n=this.points,e=n.length;if(0===e)return null;if(1===e)return n[0].clone();if(t<=0)return n[0].clone();if(1<=t)return n[e-1].clone();var i=this.length()*t;return this.pointAtLength(i)},pointAtLength:function(t){var n=this.points,e=n.length;if(0===e)return null;if(1===e)return n[0].clone();var i=!0;t<0&&(i=!1,t=-t);for(var r=0,s=e-1,o=i?0:s-1;i?o<s:0<=o;i?o++:o--){var h=n[o],u=n[o+1],a=new p(h,u),c=h.distance(u);if(t<=r+c)return a.pointAtLength((i?1:-1)*(t-r));r+=c}return(i?n[e-1]:n[0]).clone()},scale:function(t,n,e){var i=this.points,r=i.length;if(0===r)return this;for(var s=0;s<r;s++)i[s].scale(t,n,e);return this},tangentAt:function(t){var n=this.points.length;if(0===n)return null;if(1===n)return null;t<0&&(t=0),1<t&&(t=1);var e=this.length()*t;return this.tangentAtLength(e)},tangentAtLength:function(t){var n=this.points,e=n.length;if(0===e)return null;if(1===e)return null;var i,r=!0;t<0&&(r=!1,t=-t);for(var s=0,o=e-1,h=r?0:o-1;r?h<o:0<=h;r?h++:h--){var u=n[h],a=n[h+1],c=new p(u,a),l=u.distance(a);if(c.isDifferentiable()){if(t<=s+l)return c.tangentAtLength((r?1:-1)*(t-s));i=c}s+=l}if(i){var f=r?1:0;return i.tangentAt(f)}return null},toString:function(){return this.points+""},translate:function(t,n){var e=this.points,i=e.length;if(0===i)return this;for(var r=0;r<i;r++)e[r].translate(t,n);return this},serialize:function(){var t=this.points,n=t.length;if(0===n)return"";for(var e="",i=0;i<n;i++){var r=t[i];e+=r.x+","+r.y+" "}return e.trim()}},Object.defineProperty(T.prototype,"start",{configurable:!0,enumerable:!0,get:function(){return 0===this.points.length?null:this.points[0]}}),Object.defineProperty(T.prototype,"end",{configurable:!0,enumerable:!0,get:function(){var t=this.points.length;return 0===t?null:this.points[t-1]}});var M=o.Rect=function(t,n,e,i){if(!(this instanceof M))return new M(t,n,e,i);Object(t)===t&&(n=t.y,e=t.width,i=t.height,t=t.x),this.x=void 0===t?0:t,this.y=void 0===n?0:n,this.width=void 0===e?0:e,this.height=void 0===i?0:i};M.fromEllipse=function(t){return t=new i(t),new M(t.x-t.a,t.y-t.b,2*t.a,2*t.b)},M.prototype={bbox:function(t){if(!t)return this.clone();var n=w(t),e=R(a(n)),i=R(u(n)),r=this.width*i+this.height*e,s=this.width*e+this.height*i;return new M(this.x+(this.width-r)/2,this.y+(this.height-s)/2,r,s)},bottomLeft:function(){return new y(this.x,this.y+this.height)},bottomLine:function(){return new p(this.bottomLeft(),this.bottomRight())},bottomMiddle:function(){return new y(this.x+this.width/2,this.y+this.height)},center:function(){return new y(this.x+this.width/2,this.y+this.height/2)},clone:function(){return new M(this)},containsPoint:function(t){return(t=new y(t)).x>=this.x&&t.x<=this.x+this.width&&t.y>=this.y&&t.y<=this.y+this.height},containsRect:function(t){var n=new M(this).normalize(),e=new M(t).normalize(),i=n.width,r=n.height,s=e.width,o=e.height;if(!(i&&r&&s&&o))return!1;var h=n.x,u=n.y,a=e.x,c=e.y;return s+=a,i+=h,o+=c,r+=u,h<=a&&s<=i&&u<=c&&o<=r},corner:function(){return new y(this.x+this.width,this.y+this.height)},equals:function(t){var n=new M(this).normalize(),e=new M(t).normalize();return n.x===e.x&&n.y===e.y&&n.width===e.width&&n.height===e.height},inflate:function(t,n){return void 0===t&&(t=0),void 0===n&&(n=t),this.x-=t,this.y-=n,this.width+=2*t,this.height+=2*n,this},intersect:function(t){var n=this.origin(),e=this.corner(),i=t.origin(),r=t.corner();if(r.x<=n.x||r.y<=n.y||i.x>=e.x||i.y>=e.y)return null;var s=j(n.x,i.x),o=j(n.y,i.y);return new M(s,o,z(e.x,r.x)-s,z(e.y,r.y)-o)},intersectionWithLine:function(t){var n,e,i=[this.topLine(),this.rightLine(),this.bottomLine(),this.leftLine()],r=[],s=[],o=i.length;for(e=0;e<o;e++)null!==(n=t.intersect(i[e]))&&s.indexOf(n.toString())<0&&(r.push(n),s.push(n.toString()));return 0<r.length?r:null},intersectionWithLineFromCenterToPoint:function(t,n){t=new y(t);var e,i=new y(this.x+this.width/2,this.y+this.height/2);n&&t.rotate(i,n);for(var r=[this.topLine(),this.rightLine(),this.bottomLine(),this.leftLine()],s=new p(i,t),o=r.length-1;0<=o;--o){var h=r[o].intersection(s);if(null!==h){e=h;break}}return e&&n&&e.rotate(i,-n),e},leftLine:function(){return new p(this.topLeft(),this.bottomLeft())},leftMiddle:function(){return new y(this.x,this.y+this.height/2)},maxRectScaleToFit:function(t,n){var e,i,r,s,o,h,u,a;t=new M(t),n||(n=t.center());var c=n.x,l=n.y;e=i=r=s=o=h=u=a=1/0;var f=t.topLeft();f.x<c&&(e=(this.x-c)/(f.x-c)),f.y<l&&(o=(this.y-l)/(f.y-l));var g=t.bottomRight();g.x>c&&(i=(this.x+this.width-c)/(g.x-c)),g.y>l&&(h=(this.y+this.height-l)/(g.y-l));var p=t.topRight();p.x>c&&(r=(this.x+this.width-c)/(p.x-c)),p.y<l&&(u=(this.y-l)/(p.y-l));var d=t.bottomLeft();return d.x<c&&(s=(this.x-c)/(d.x-c)),d.y>l&&(a=(this.y+this.height-l)/(d.y-l)),{sx:z(e,i,r,s),sy:z(o,h,u,a)}},maxRectUniformScaleToFit:function(t,n){var e=this.maxRectScaleToFit(t,n);return z(e.sx,e.sy)},moveAndExpand:function(t){return this.x+=t.x||0,this.y+=t.y||0,this.width+=t.width||0,this.height+=t.height||0,this},normalize:function(){var t=this.x,n=this.y,e=this.width,i=this.height;return this.width<0&&(t=this.x+this.width,e=-this.width),this.height<0&&(n=this.y+this.height,i=-this.height),this.x=t,this.y=n,this.width=e,this.height=i,this},offset:function(t,n){return y.prototype.offset.call(this,t,n)},origin:function(){return new y(this.x,this.y)},pointNearestToPoint:function(t){if(t=new y(t),this.containsPoint(t))switch(this.sideNearestToPoint(t)){case"right":return new y(this.x+this.width,t.y);case"left":return new y(this.x,t.y);case"bottom":return new y(t.x,this.y+this.height);case"top":return new y(t.x,this.y)}return t.adhereToRect(this)},rightLine:function(){return new p(this.topRight(),this.bottomRight())},rightMiddle:function(){return new y(this.x+this.width,this.y+this.height/2)},round:function(t){var n=E(10,t||0);return this.x=e(this.x*n)/n,this.y=e(this.y*n)/n,this.width=e(this.width*n)/n,this.height=e(this.height*n)/n,this},scale:function(t,n,e){return e=this.origin().scale(t,n,e),this.x=e.x,this.y=e.y,this.width*=t,this.height*=n,this},sideNearestToPoint:function(t){var n=(t=new y(t)).x-this.x,e=this.x+this.width-t.x,i=t.y-this.y,r=n,s="left";return e<r&&(r=e,s="right"),i<r&&(r=i,s="top"),this.y+this.height-t.y<r&&(s="bottom"),s},snapToGrid:function(t,n){var e=this.origin().snapToGrid(t,n),i=this.corner().snapToGrid(t,n);return this.x=e.x,this.y=e.y,this.width=i.x-e.x,this.height=i.y-e.y,this},toJSON:function(){return{x:this.x,y:this.y,width:this.width,height:this.height}},topLine:function(){return new p(this.topLeft(),this.topRight())},topMiddle:function(){return new y(this.x+this.width/2,this.y)},topRight:function(){return new y(this.x+this.width,this.y)},toString:function(){return this.origin().toString()+" "+this.corner().toString()},union:function(t){t=new M(t);var n=this.origin(),e=this.corner(),i=t.origin(),r=t.corner(),s=z(n.x,i.x),o=z(n.y,i.y),h=j(e.x,r.x),u=j(e.y,r.y);return new M(s,o,h-s,u-o)}},M.prototype.bottomRight=M.prototype.corner,M.prototype.topLeft=M.prototype.origin,M.prototype.translate=M.prototype.offset,o.scale={linear:function(t,n,e){var i=t[1]-t[0],r=n[1]-n[0];return(e-t[0])/i*r+n[0]||0}};var f=o.normalizeAngle=function(t){return t%360+(t<0?360:0)},d=o.snapToGrid=function(t,n){return n*e(t/n)},v=o.toDeg=function(t){return 180*t/s%360},w=o.toRad=function(t,n){return(t=(n=n||!1)?t:t%360)*s/180};function m(t,n){return n.unshift(null),new(Function.prototype.bind.apply(t,n))}function n(t){var n,e,i=[];for(e=arguments.length,n=1;n<e;n++)i.push(arguments[n]);if(!t)throw new Error("Missing a parent object.");var r=Object.create(t);for(e=i.length,n=0;n<e;n++){var s,o,h=i[n];for(o in h)h.hasOwnProperty(o)&&(delete r[o],s=Object.getOwnPropertyDescriptor(h,o),Object.defineProperty(r,o,s))}return r}o.ellipse=o.Ellipse,o.line=o.Line,o.point=o.Point,o.rect=o.Rect;var x={bbox:function(){throw new Error("Declaration missing for virtual function.")},clone:function(){throw new Error("Declaration missing for virtual function.")},closestPoint:function(){throw new Error("Declaration missing for virtual function.")},closestPointLength:function(){throw new Error("Declaration missing for virtual function.")},closestPointNormalizedLength:function(){throw new Error("Declaration missing for virtual function.")},closestPointT:function(t){if(this.closestPointNormalizedLength)return this.closestPointNormalizedLength(t);throw new Error("Neither closestPointT() nor closestPointNormalizedLength() function is implemented.")},closestPointTangent:function(){throw new Error("Declaration missing for virtual function.")},equals:function(){throw new Error("Declaration missing for virtual function.")},getSubdivisions:function(){throw new Error("Declaration missing for virtual function.")},isDifferentiable:function(){throw new Error("Declaration missing for virtual function.")},isSegment:!0,isSubpathStart:!1,isVisible:!0,length:function(){throw new Error("Declaration missing for virtual function.")},lengthAtT:function(t){if(t<=0)return 0;var n=this.length();return 1<=t?n:n*t},nextSegment:null,pointAt:function(){throw new Error("Declaration missing for virtual function.")},pointAtLength:function(){throw new Error("Declaration missing for virtual function.")},pointAtT:function(t){if(this.pointAt)return this.pointAt(t);throw new Error("Neither pointAtT() nor pointAt() function is implemented.")},previousSegment:null,subpathStartSegment:null,scale:function(){throw new Error("Declaration missing for virtual function.")},serialize:function(){throw new Error("Declaration missing for virtual function.")},tangentAt:function(){throw new Error("Declaration missing for virtual function.")},tangentAtLength:function(){throw new Error("Declaration missing for virtual function.")},tangentAtT:function(t){if(this.tangentAt)return this.tangentAt(t);throw new Error("Neither tangentAtT() nor tangentAt() function is implemented.")},toString:function(){throw new Error("Declaration missing for virtual function.")},translate:function(){throw new Error("Declaration missing for virtual function.")}};Object.defineProperty(x,"end",{configurable:!0,enumerable:!0,writable:!0}),Object.defineProperty(x,"start",{configurable:!0,enumerable:!0,get:function(){if(!this.previousSegment)throw new Error("Missing previous segment. (This segment cannot be the first segment of a path; OR segment has not yet been added to a path.)");return this.previousSegment.end}}),Object.defineProperty(x,"type",{configurable:!0,enumerable:!0,get:function(){throw new Error("Bad segment declaration. No type specified.")}});var b=function(){for(var t,n,e=[],i=arguments.length,r=0;r<i;r++)e.push(arguments[r]);if(!(this instanceof b))return m(b,e);if(0===i)throw new Error("Lineto constructor expects 1 point or 2 coordinates (none provided).");if("string"==typeof e[0]||"number"==typeof e[0]){if(2===i)return this.end=new y(+e[0],+e[1]),this;if(i<2)throw new Error("Lineto constructor expects 1 point or 2 coordinates ("+i+" coordinates provided).");var s;for(t=[],r=0;r<i;r+=2)s=e.slice(r,r+2),t.push(m(b,s));return t}if(1===i)return this.end=new y(e[0]),this;for(t=[],r=0;r<i;r+=1)n=e[r],t.push(new b(n));return t},S={clone:function(){return new b(this.end)},getSubdivisions:function(){return[]},isDifferentiable:function(){return!!this.previousSegment&&!this.start.equals(this.end)},scale:function(t,n,e){return this.end.scale(t,n,e),this},serialize:function(){var t=this.end;return this.type+" "+t.x+" "+t.y},toString:function(){return this.type+" "+this.start+" "+this.end},translate:function(t,n){return this.end.translate(t,n),this}};Object.defineProperty(S,"type",{configurable:!0,enumerable:!0,value:"L"}),b.prototype=n(x,p.prototype,S);var P=function(){for(var t,n,e=[],i=arguments.length,r=0;r<i;r++)e.push(arguments[r]);if(!(this instanceof P))return m(P,e);if(0===i)throw new Error("Curveto constructor expects 3 points or 6 coordinates (none provided).");if("string"==typeof e[0]||"number"==typeof e[0]){if(6===i)return this.controlPoint1=new y(+e[0],+e[1]),this.controlPoint2=new y(+e[2],+e[3]),this.end=new y(+e[4],+e[5]),this;if(i<6)throw new Error("Curveto constructor expects 3 points or 6 coordinates ("+i+" coordinates provided).");var s;for(t=[],r=0;r<i;r+=6)s=e.slice(r,r+6),t.push(m(P,s));return t}if(3===i)return this.controlPoint1=new y(e[0]),this.controlPoint2=new y(e[1]),this.end=new y(e[2]),this;if(i<3)throw new Error("Curveto constructor expects 3 points or 6 coordinates ("+i+" points provided).");for(t=[],r=0;r<i;r+=3)n=e.slice(r,r+3),t.push(m(P,n));return t},A={clone:function(){return new P(this.controlPoint1,this.controlPoint2,this.end)},isDifferentiable:function(){if(!this.previousSegment)return!1;var t=this.start,n=this.controlPoint1,e=this.controlPoint2,i=this.end;return!(t.equals(n)&&n.equals(e)&&e.equals(i))},scale:function(t,n,e){return this.controlPoint1.scale(t,n,e),this.controlPoint2.scale(t,n,e),this.end.scale(t,n,e),this},serialize:function(){var t=this.controlPoint1,n=this.controlPoint2,e=this.end;return this.type+" "+t.x+" "+t.y+" "+n.x+" "+n.y+" "+e.x+" "+e.y},toString:function(){return this.type+" "+this.start+" "+this.controlPoint1+" "+this.controlPoint2+" "+this.end},translate:function(t,n){return this.controlPoint1.translate(t,n),this.controlPoint2.translate(t,n),this.end.translate(t,n),this}};Object.defineProperty(A,"type",{configurable:!0,enumerable:!0,value:"C"}),P.prototype=n(x,g.prototype,A);var L=function(){for(var t,n,e=[],i=arguments.length,r=0;r<i;r++)e.push(arguments[r]);if(!(this instanceof L))return m(L,e);if(0===i)throw new Error("Moveto constructor expects 1 point or 2 coordinates (none provided).");if("string"==typeof e[0]||"number"==typeof e[0]){if(2===i)return this.end=new y(+e[0],+e[1]),this;if(i<2)throw new Error("Moveto constructor expects 1 point or 2 coordinates ("+i+" coordinates provided).");var s;for(t=[],r=0;r<i;r+=2)s=e.slice(r,r+2),0===r?t.push(m(L,s)):t.push(m(b,s));return t}if(1===i)return this.end=new y(e[0]),this;for(t=[],r=0;r<i;r+=1)n=e[r],0===r?t.push(new L(n)):t.push(new b(n));return t},I={bbox:function(){return null},clone:function(){return new L(this.end)},closestPoint:function(){return this.end.clone()},closestPointNormalizedLength:function(){return 0},closestPointLength:function(){return 0},closestPointT:function(){return 1},closestPointTangent:function(){return null},equals:function(t){return this.end.equals(t.end)},getSubdivisions:function(){return[]},isDifferentiable:function(){return!1},isSubpathStart:!0,isVisible:!1,length:function(){return 0},lengthAtT:function(){return 0},pointAt:function(){return this.end.clone()},pointAtLength:function(){return this.end.clone()},pointAtT:function(){return this.end.clone()},scale:function(t,n,e){return this.end.scale(t,n,e),this},serialize:function(){var t=this.end;return this.type+" "+t.x+" "+t.y},tangentAt:function(){return null},tangentAtLength:function(){return null},tangentAtT:function(){return null},toString:function(){return this.type+" "+this.end},translate:function(t,n){return this.end.translate(t,n),this}};Object.defineProperty(I,"start",{configurable:!0,enumerable:!0,get:function(){throw new Error("Illegal access. Moveto segments should not need a start property.")}}),Object.defineProperty(I,"type",{configurable:!0,enumerable:!0,value:"M"}),L.prototype=n(x,I);var C=function(){for(var t=[],n=arguments.length,e=0;e<n;e++)t.push(arguments[e]);if(!(this instanceof C))return m(C,t);if(0<n)throw new Error("Closepath constructor expects no arguments.");return this},N={clone:function(){return new C},getSubdivisions:function(){return[]},isDifferentiable:function(){return!(!this.previousSegment||!this.subpathStartSegment)&&!this.start.equals(this.end)},scale:function(){return this},serialize:function(){return this.type},toString:function(){return this.type+" "+this.start+" "+this.end},translate:function(){return this}};Object.defineProperty(N,"end",{configurable:!0,enumerable:!0,get:function(){if(!this.subpathStartSegment)throw new Error("Missing subpath start segment. (This segment needs a subpath start segment (e.g. Moveto); OR segment has not yet been added to a path.)");return this.subpathStartSegment.end}}),Object.defineProperty(N,"type",{configurable:!0,enumerable:!0,value:"Z"}),C.prototype=n(x,p.prototype,N);var O=l.segmentTypes={L:b,C:P,M:L,Z:C,z:C};l.regexSupportedData=new RegExp("^[\\s\\d"+Object.keys(O).join("")+",.]*$"),l.isDataSupported=function(t){return"string"==typeof t&&this.regexSupportedData.test(t)}}(g);

    return g;

}));
