/*! JointJS v2.2.0 (2018-10-30) - JavaScript diagramming library


This Source Code Form is subject to the terms of the Mozilla Public
License, v. 2.0. If a copy of the MPL was not distributed with this
file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/
(function(root, factory) {

    if (typeof define === 'function' && define.amd) {

        // AMD. Register as an anonymous module.
        define(['g'], function(g) {
            return factory(g);
        });

    } else if (typeof exports === 'object') {

        // Node. Does not work with strict CommonJS, but
        // only CommonJS-like environments that support module.exports,
        // like Node.
        var g = require('./geometry');

        module.exports = factory(g);

    } else {

        // Browser globals.
        var g = root.g;

        root.Vectorizer = root.V = factory(g);
    }

}(this, function(g) {

var V,Vectorizer;V=Vectorizer=function(){"use strict";if(!("object"==typeof window&&!(!window.SVGAngle&&!document.implementation.hasFeature("http://www.w3.org/TR/SVG11/feature#BasicStructure","1.1"))))return function(){throw new Error("SVG is required to use Vectorizer.")};var c={xmlns:"http://www.w3.org/2000/svg",xml:"http://www.w3.org/XML/1998/namespace",xlink:"http://www.w3.org/1999/xlink",xhtml:"http://www.w3.org/1999/xhtml"},t=Math,v=t.PI,i=t.atan2,s=t.sqrt,h=t.min,f=t.max,p=t.cos,x=t.sin,N=function(t,e,r){if(!(this instanceof N))return N.apply(Object.create(N.prototype),arguments);if(t){if(N.isV(t)&&(t=t.node),e=e||{},N.isString(t)){if("svg"===t.toLowerCase())t=N.createSvgDocument();else if("<"===t[0]){var n=N.createSvgDocument(t);if(1<n.childNodes.length){var a,i,s=[];for(a=0,i=n.childNodes.length;a<i;a++){var o=n.childNodes[a];s.push(new N(document.importNode(o,!0)))}return s}t=document.importNode(n.firstChild,!0)}else t=document.createElementNS(c.xmlns,t);N.ensureId(t)}return this.node=t,this.setAttributes(e),r&&this.append(r),this}},e=N.prototype;function V(t,e,r){r||(r={});for(var n=r.includeAnnotationIndices,a=r.eol,i=r.lineHeight,s=r.baseSize,o=0,c={},l=e.length-1,u=0;u<=l;u++){var h=e[u],f=null;if(N.isObject(h)){var d=h.attrs,m=N("tspan",d),v=m.node,g=h.t;a&&u===l&&(g+=a),v.textContent=g;var p=d.class;p&&m.addClass(p),n&&m.attr("annotations",h.annotations),void 0===(f=parseFloat(d["font-size"]))&&(f=s),f&&o<f&&(o=f)}else a&&u===l&&(h+=a),v=document.createTextNode(h||" "),s&&o<s&&(o=s);t.appendChild(v)}return o&&(c.maxFontSize=o),i?c.lineHeight=i:o&&(c.lineHeight=1.2*o),c}Object.defineProperty(e,"id",{enumerable:!0,get:function(){return this.node.id},set:function(t){this.node.id=t}}),e.getTransformToElement=function(t){var e=this.node;if(N.isSVGGraphicsElement(t)&&N.isSVGGraphicsElement(e)){var r=N.toNode(t).getScreenCTM(),n=e.getScreenCTM();if(r&&n)return r.inverse().multiply(n)}return N.createSVGMatrix()},e.transform=function(t,e){var r=this.node;if(N.isUndefined(t))return N.transformStringToMatrix(this.attr("transform"));if(e&&e.absolute)return this.attr("transform",N.matrixToTransformString(t));var n=N.createSVGTransform(t);return r.transform.baseVal.appendItem(n),this},e.translate=function(t,e,r){r=r||{},e=e||0;var n=this.attr("transform")||"",a=N.parseTransformString(n);if(n=a.value,N.isUndefined(t))return a.translate;n=n.replace(/translate\([^)]*\)/g,"").trim();var i="translate("+(r.absolute?t:a.translate.tx+t)+","+(r.absolute?e:a.translate.ty+e)+")";return this.attr("transform",(i+" "+n).trim()),this},e.rotate=function(t,e,r,n){n=n||{};var a=this.attr("transform")||"",i=N.parseTransformString(a);if(a=i.value,N.isUndefined(t))return i.rotate;a=a.replace(/rotate\([^)]*\)/g,"").trim(),t%=360;var s="rotate("+(n.absolute?t:i.rotate.angle+t)+(void 0!==e&&void 0!==r?","+e+","+r:"")+")";return this.attr("transform",(a+" "+s).trim()),this},e.scale=function(t,e){e=N.isUndefined(e)?t:e;var r=this.attr("transform")||"",n=N.parseTransformString(r);if(r=n.value,N.isUndefined(t))return n.scale;r=r.replace(/scale\([^)]*\)/g,"").trim();var a="scale("+t+","+e+")";return this.attr("transform",(r+" "+a).trim()),this},e.bbox=function(t,e){var r,n=this.node,a=n.ownerSVGElement;if(!a)return new g.Rect(0,0,0,0);try{r=n.getBBox()}catch(t){r={x:n.clientLeft,y:n.clientTop,width:n.clientWidth,height:n.clientHeight}}if(t)return new g.Rect(r);var i=this.getTransformToElement(e||a);return N.transformRect(r,i)},e.getBBox=function(t){var e,r={},n=this.node;if(!n.ownerSVGElement||!N.isSVGGraphicsElement(n))return new g.Rect(0,0,0,0);if(t&&(t.target&&(r.target=N.toNode(t.target)),t.recursive&&(r.recursive=t.recursive)),r.recursive){var a=this.children(),i=a.length;if(0===i)return this.getBBox({target:r.target,recursive:!1});r.target||(r.target=this);for(var s=0;s<i;s++){var o,c=a[s];o=0===c.children().length?c.getBBox({target:r.target,recursive:!1}):c.getBBox({target:r.target,recursive:!0}),e=e?e.union(o):o}return e}try{e=n.getBBox()}catch(t){e={x:n.clientLeft,y:n.clientTop,width:n.clientWidth,height:n.clientHeight}}if(r.target){var l=this.getTransformToElement(r.target);return N.transformRect(e,l)}return new g.Rect(e)};var L=/em$/;function M(t,e){var r=parseFloat(t);return L.test(t)?r*e:r}e.text=function(t,e){if(t&&"string"!=typeof t)throw new Error("Vectorizer: text() expects the first argument to be a string.");t=N.sanitizeText(t),e||(e={});var r=e.eol,n=e.textPath,a=e.textVerticalAnchor,i="middle"===a||"bottom"===a||"top"===a,s=e.x;void 0===s&&(s=this.attr("x")||0);var o=e.includeAnnotationIndices,c=e.annotations;c&&!N.isArray(c)&&(c=[c]);var l=e.lineHeight,u="auto"===l,h=u?"1.5em":l||"1em";this.empty(),this.attr({"xml:space":"preserve",display:t?null:"none"});var f=parseFloat(this.attr("font-size"));f||(f=16,(i||c)&&this.attr("font-size",f));var d,m=document;d=n?("string"==typeof n&&(n={d:n}),function(t,e){t||(t={});var r=N("textPath"),n=t.d;if(n&&void 0===t["xlink:href"]){var a=N("path").attr("d",n).appendTo(e.defs());r.attr("xlink:href","#"+a.id)}return N.isObject(t)&&r.attr(t),r.node}(n,this)):m.createDocumentFragment();for(var v,g=0,p=t.split("\n"),x=[],y=0,T=p.length-1;y<=T;y++){var b,P=h,w="v-line",A=m.createElementNS(N.namespace.xmlns,"tspan"),S=p[y];if(S)if(c){var F=(b=V(A,N.annotateString(S,c,{offset:-g,includeAnnotationIndices:o}),{includeAnnotationIndices:o,eol:y!==T&&r,lineHeight:u?null:h,baseSize:f})).lineHeight;F&&u&&0!==y&&(P=F),0===y&&(v=.8*b.maxFontSize)}else r&&y!==T&&(S+=r),A.textContent=S;else{A.textContent="-",w+=" v-empty-line";var C=A.style;C.fillOpacity=0,C.strokeOpacity=0,c&&(b={})}b&&x.push(b),0<y&&A.setAttribute("dy",P),(0<y||n)&&A.setAttribute("x",s),A.className.baseVal=w,d.appendChild(A),g+=S.length+1}if(i)if(c)P=function(t,e,r,n){if(!Array.isArray(e))return 0;var a=e.length;if(!a)return 0;for(var i=e[0],s=M(i.maxFontSize,r)||r,o=0,c=M(n,r),l=1;l<a;l++)o+=M((i=e[l]).lineHeight,r)||c;var u,h=M(i.maxFontSize,r)||r;switch(t){case"middle":u=s/2-.15*h-o/2;break;case"bottom":u=-.25*h-o;break;default:case"top":u=.8*s}return u}(a,x,f,h);else if("top"===a)P="0.8em";else{var E;switch(0<T?(E=parseFloat(h)||1,E*=T,L.test(h)||(E/=f)):E=0,a){case"middle":P=.3-E/2+"em";break;case"bottom":P=-E-.3+"em"}}else 0===a?P="0em":a?P=a:(P=0,null===this.attr("y")&&this.attr("y",v||"0.8em"));return d.firstChild.setAttribute("dy",P),this.append(d),this},e.removeAttr=function(t){var e=N.qualifyAttr(t),r=this.node;return e.ns?r.hasAttributeNS(e.ns,e.local)&&r.removeAttributeNS(e.ns,e.local):r.hasAttribute(t)&&r.removeAttribute(t),this},e.attr=function(t,e){if(N.isUndefined(t)){for(var r=this.node.attributes,n={},a=0;a<r.length;a++)n[r[a].name]=r[a].value;return n}if(N.isString(t)&&N.isUndefined(e))return this.node.getAttribute(t);if("object"==typeof t)for(var i in t)t.hasOwnProperty(i)&&this.setAttribute(i,t[i]);else this.setAttribute(t,e);return this},e.normalizePath=function(){return"PATH"===this.tagName()&&this.attr("d",N.normalizePathData(this.attr("d"))),this},e.remove=function(){return this.node.parentNode&&this.node.parentNode.removeChild(this.node),this},e.empty=function(){for(;this.node.firstChild;)this.node.removeChild(this.node.firstChild);return this},e.setAttributes=function(t){for(var e in t)t.hasOwnProperty(e)&&this.setAttribute(e,t[e]);return this},e.append=function(t){N.isArray(t)||(t=[t]);for(var e=0,r=t.length;e<r;e++)this.node.appendChild(N.toNode(t[e]));return this},e.prepend=function(t){var e=this.node.firstChild;return e?N(e).before(t):this.append(t)},e.before=function(t){var e=this.node,r=e.parentNode;if(r){N.isArray(t)||(t=[t]);for(var n=0,a=t.length;n<a;n++)r.insertBefore(N.toNode(t[n]),e)}return this},e.appendTo=function(t){return N.toNode(t).appendChild(this.node),this},e.svg=function(){return this.node instanceof window.SVGSVGElement?this:N(this.node.ownerSVGElement)},e.tagName=function(){return this.node.tagName.toUpperCase()},e.defs=function(){var t=this.svg()||this,e=t.node.getElementsByTagName("defs")[0];return e?N(e):N("defs").appendTo(t)},e.clone=function(){var t=N(this.node.cloneNode(!0));return t.node.id=N.uniqueId(),t},e.findOne=function(t){var e=this.node.querySelector(t);return e?N(e):void 0},e.find=function(t){var e=[],r=this.node.querySelectorAll(t);if(r)for(var n=0;n<r.length;n++)e.push(N(r[n]));return e},e.children=function(){for(var t=this.node.childNodes,e=[],r=0;r<t.length;r++){1===t[r].nodeType&&e.push(N(t[r]))}return e},e.index=function(){for(var t=0,e=this.node.previousSibling;e;)1===e.nodeType&&t++,e=e.previousSibling;return t},e.findParentByClass=function(t,e){for(var r=this.node.ownerSVGElement,n=this.node.parentNode;n&&n!==e&&n!==r;){var a=N(n);if(a.hasClass(t))return a;n=n.parentNode}return null},e.contains=function(t){var e=this.node,r=N.toNode(t),n=r&&r.parentNode;return e===n||!!(n&&1===n.nodeType&&16&e.compareDocumentPosition(n))},e.toLocalPoint=function(t,e){var r=this.svg().node,n=r.createSVGPoint();n.x=t,n.y=e;try{var a=n.matrixTransform(r.getScreenCTM().inverse()),i=this.getTransformToElement(r).inverse()}catch(t){return n}return a.matrixTransform(i)},e.translateCenterToPoint=function(t){var e=this.getBBox({target:this.svg()}).center();return this.translate(t.x-e.x,t.y-e.y),this},e.translateAndAutoOrient=function(t,e,r){var n=this.scale();this.attr("transform",""),this.scale(n.sx,n.sy);var a=this.svg().node,i=this.getBBox({target:r||a}),s=a.createSVGTransform();s.setTranslate(-i.x-i.width/2,-i.y-i.height/2);var o=a.createSVGTransform(),c=new g.Point(t).changeInAngle(t.x-e.x,t.y-e.y,e);o.setRotate(c,0,0);var l=a.createSVGTransform(),u=new g.Point(t).move(e,i.width/2);l.setTranslate(t.x+(t.x-u.x),t.y+(t.y-u.y));var h=this.getTransformToElement(r||a),f=a.createSVGTransform();f.setMatrix(l.matrix.multiply(o.matrix.multiply(s.matrix.multiply(h))));var d=N.decomposeMatrix(f.matrix);return this.translate(d.translateX,d.translateY),this.rotate(d.rotation),this},e.animateAlongPath=function(t,e){e=N.toNode(e);var r=N.ensureId(e),n=N("animateMotion",t),a=N("mpath",{"xlink:href":"#"+r});n.append(a),this.append(n);try{n.node.beginElement()}catch(t){if("fake"===document.documentElement.getAttribute("smiling")){var i=n.node;i.animators=[];var s=i.getAttribute("id");s&&(id2anim[s]=i);for(var o=getTargets(i),c=0,l=o.length;c<l;c++){var u=o[c],h=new Animator(i,u,c);animators.push(h),(i.animators[c]=h).register()}}}return this},e.hasClass=function(t){return new RegExp("(\\s|^)"+t+"(\\s|$)").test(this.node.getAttribute("class"))},e.addClass=function(t){if(t&&!this.hasClass(t)){var e=this.node.getAttribute("class")||"";this.node.setAttribute("class",(e+" "+t).trim())}return this},e.removeClass=function(t){if(t&&this.hasClass(t)){var e=this.node.getAttribute("class").replace(new RegExp("(\\s|^)"+t+"(\\s|$)","g"),"$2");this.node.setAttribute("class",e)}return this},e.toggleClass=function(t,e){return(N.isUndefined(e)?this.hasClass(t):!e)?this.removeClass(t):this.addClass(t),this},e.sample=function(t){t=t||1;for(var e,r=this.node,n=r.getTotalLength(),a=[],i=0;i<n;)e=r.getPointAtLength(i),a.push({x:e.x,y:e.y,distance:i}),i+=t;return a},e.convertToPath=function(){var t=N("path");t.attr(this.attr());var e=this.convertToPathData();return e&&t.attr("d",e),t},e.convertToPathData=function(){var t=this.tagName();switch(t){case"PATH":return this.attr("d");case"LINE":return N.convertLineToPathData(this.node);case"POLYGON":return N.convertPolygonToPathData(this.node);case"POLYLINE":return N.convertPolylineToPathData(this.node);case"ELLIPSE":return N.convertEllipseToPathData(this.node);case"CIRCLE":return N.convertCircleToPathData(this.node);case"RECT":return N.convertRectToPathData(this.node)}throw new Error(t+" cannot be converted to PATH.")},N.prototype.toGeometryShape=function(){var t,e,r,n,a,i,s,o,c,l,u,h,f,d,m;switch(this.tagName()){case"RECT":return t=parseFloat(this.attr("x"))||0,e=parseFloat(this.attr("y"))||0,r=parseFloat(this.attr("width"))||0,n=parseFloat(this.attr("height"))||0,new g.Rect(t,e,r,n);case"CIRCLE":return a=parseFloat(this.attr("cx"))||0,i=parseFloat(this.attr("cy"))||0,s=parseFloat(this.attr("r"))||0,new g.Ellipse({x:a,y:i},s,s);case"ELLIPSE":return a=parseFloat(this.attr("cx"))||0,i=parseFloat(this.attr("cy"))||0,o=parseFloat(this.attr("rx"))||0,c=parseFloat(this.attr("ry"))||0,new g.Ellipse({x:a,y:i},o,c);case"POLYLINE":return l=N.getPointsFromSvgNode(this),new g.Polyline(l);case"POLYGON":return 1<(l=N.getPointsFromSvgNode(this)).length&&l.push(l[0]),new g.Polyline(l);case"PATH":return u=this.attr("d"),g.Path.isDataSupported(u)||(u=N.normalizePathData(u)),new g.Path(u);case"LINE":return h=parseFloat(this.attr("x1"))||0,d=parseFloat(this.attr("y1"))||0,f=parseFloat(this.attr("x2"))||0,m=parseFloat(this.attr("y2"))||0,new g.Line({x:h,y:d},{x:f,y:m})}return this.getBBox()},e.findIntersection=function(t,e){var r=this.svg().node;e=e||r;var n=this.getBBox({target:e}),a=n.center();if(n.intersectionWithLineFromCenterToPoint(t)){var i,s=this.tagName();if("RECT"===s){var o=new g.Rect(parseFloat(this.attr("x")||0),parseFloat(this.attr("y")||0),parseFloat(this.attr("width")),parseFloat(this.attr("height"))),c=this.getTransformToElement(e),l=N.decomposeMatrix(c),u=r.createSVGTransform();u.setRotate(-l.rotation,a.x,a.y);var h=N.transformRect(o,u.matrix.multiply(c));i=new g.Rect(h).intersectionWithLineFromCenterToPoint(t,l.rotation)}else if("PATH"===s||"POLYGON"===s||"POLYLINE"===s||"CIRCLE"===s||"ELLIPSE"===s){var f,d,m,v,p,x=("PATH"===s?this:this.convertToPath()).sample(),y=1/0,T=[];for(f=0;f<x.length;f++)d=x[f],m=(m=N.createSVGPoint(d.x,d.y)).matrixTransform(this.getTransformToElement(e)),(p=(d=new g.Point(m)).distance(a)+(v=1.1*d.distance(t)))<y?(y=p,T=[{sample:d,refDistance:v}]):p<y+1&&T.push({sample:d,refDistance:v});T.sort(function(t,e){return t.refDistance-e.refDistance}),T[0]&&(i=T[0].sample)}return i}},e.setAttribute=function(t,e){var r=this.node;if(null===e)return this.removeAttr(t),this;var n=N.qualifyAttr(t);return n.ns?r.setAttributeNS(n.ns,t,e):"id"===t?r.id=e:r.setAttribute(t,e),this},N.createSvgDocument=function(t){var e='<svg xmlns="'+c.xmlns+'" xmlns:xlink="'+c.xlink+'" version="1.1">'+(t||"")+"</svg>";return N.parseXML(e,{async:!1}).documentElement},N.idCounter=0,N.uniqueId=function(){return"v-"+ ++N.idCounter},N.toNode=function(t){return N.isV(t)?t.node:t.nodeName&&t||t[0]},N.ensureId=function(t){return(t=N.toNode(t)).id||(t.id=N.uniqueId())},N.sanitizeText=function(t){return(t||"").replace(/ /g," ")},N.isUndefined=function(t){return void 0===t},N.isString=function(t){return"string"==typeof t},N.isObject=function(t){return t&&"object"==typeof t},N.isArray=Array.isArray,N.parseXML=function(t,e){var r;e=e||{};try{var n=new DOMParser;N.isUndefined(e.async)||(n.async=e.async),r=n.parseFromString(t,"text/xml")}catch(t){r=void 0}if(!r||r.getElementsByTagName("parsererror").length)throw new Error("Invalid XML: "+t);return r},N.qualifyAttr=function(t){if(-1===t.indexOf(":"))return{ns:null,local:t};var e=t.split(":");return{ns:c[e[0]],local:e[1]}},N.transformRegex=/(\w+)\(([^,)]+),?([^)]+)?\)/gi,N.transformSeparatorRegex=/[ ,]+/,N.transformationListRegex=/^(\w+)\((.*)\)/,N.transformStringToMatrix=function(t){var e=N.createSVGMatrix(),r=t&&t.match(N.transformRegex);if(!r)return e;for(var n=0,a=r.length;n<a;n++){var i=r[n].match(N.transformationListRegex);if(i){var s,o,c,l,u,h=N.createSVGMatrix(),f=i[2].split(N.transformSeparatorRegex);switch(i[1].toLowerCase()){case"scale":s=parseFloat(f[0]),o=void 0===f[1]?s:parseFloat(f[1]),h=h.scaleNonUniform(s,o);break;case"translate":c=parseFloat(f[0]),l=parseFloat(f[1]),h=h.translate(c,l);break;case"rotate":u=parseFloat(f[0]),c=parseFloat(f[1])||0,l=parseFloat(f[2])||0,h=0!==c||0!==l?h.translate(c,l).rotate(u).translate(-c,-l):h.rotate(u);break;case"skewx":u=parseFloat(f[0]),h=h.skewX(u);break;case"skewy":u=parseFloat(f[0]),h=h.skewY(u);break;case"matrix":h.a=parseFloat(f[0]),h.b=parseFloat(f[1]),h.c=parseFloat(f[2]),h.d=parseFloat(f[3]),h.e=parseFloat(f[4]),h.f=parseFloat(f[5]);break;default:continue}e=e.multiply(h)}}return e},N.matrixToTransformString=function(t){return t||(t=!0),"matrix("+(void 0!==t.a?t.a:1)+","+(void 0!==t.b?t.b:0)+","+(void 0!==t.c?t.c:0)+","+(void 0!==t.d?t.d:1)+","+(void 0!==t.e?t.e:0)+","+(void 0!==t.f?t.f:0)+")"},N.parseTransformString=function(t){var e,r,n;if(t){var a=N.transformSeparatorRegex;if(0<=t.trim().indexOf("matrix")){var i=N.transformStringToMatrix(t),s=N.decomposeMatrix(i);e=[s.translateX,s.translateY],n=[s.scaleX,s.scaleY],r=[s.rotation];var o=[];0===e[0]&&0===e[1]||o.push("translate("+e+")"),1===n[0]&&1===n[1]||o.push("scale("+n+")"),0!==r[0]&&o.push("rotate("+r+")"),t=o.join(" ")}else{var c=t.match(/translate\((.*?)\)/);c&&(e=c[1].split(a));var l=t.match(/rotate\((.*?)\)/);l&&(r=l[1].split(a));var u=t.match(/scale\((.*?)\)/);u&&(n=u[1].split(a))}}var h=n&&n[0]?parseFloat(n[0]):1;return{value:t,translate:{tx:e&&e[0]?parseInt(e[0],10):0,ty:e&&e[1]?parseInt(e[1],10):0},rotate:{angle:r&&r[0]?parseInt(r[0],10):0,cx:r&&r[1]?parseInt(r[1],10):void 0,cy:r&&r[2]?parseInt(r[2],10):void 0},scale:{sx:h,sy:n&&n[1]?parseFloat(n[1]):h}}},N.deltaTransformPoint=function(t,e){return{x:e.x*t.a+e.y*t.c+0,y:e.x*t.b+e.y*t.d+0}},N.decomposeMatrix=function(t){var e=N.deltaTransformPoint(t,{x:0,y:1}),r=N.deltaTransformPoint(t,{x:1,y:0}),n=180/v*i(e.y,e.x)-90,a=180/v*i(r.y,r.x);return{translateX:t.e,translateY:t.f,scaleX:s(t.a*t.a+t.b*t.b),scaleY:s(t.c*t.c+t.d*t.d),skewX:n,skewY:a,rotation:n}},N.matrixToScale=function(t){var e,r,n,a;return t?(e=N.isUndefined(t.a)?1:t.a,a=N.isUndefined(t.d)?1:t.d,r=t.b,n=t.c):e=a=1,{sx:r?s(e*e+r*r):e,sy:n?s(n*n+a*a):a}},N.matrixToRotate=function(t){var e={x:0,y:1};return t&&(e=N.deltaTransformPoint(t,e)),{angle:g.normalizeAngle(g.toDeg(i(e.y,e.x))-90)}},N.matrixToTranslate=function(t){return{tx:t&&t.e||0,ty:t&&t.f||0}},N.isV=function(t){return t instanceof N},N.isVElement=N.isV,N.isSVGGraphicsElement=function(t){return!!t&&((t=N.toNode(t))instanceof SVGElement&&"function"==typeof t.getScreenCTM)};var d=N("svg").node;return N.createSVGMatrix=function(t){var e=d.createSVGMatrix();for(var r in t)e[r]=t[r];return e},N.createSVGTransform=function(t){return N.isUndefined(t)?d.createSVGTransform():(t instanceof SVGMatrix||(t=N.createSVGMatrix(t)),d.createSVGTransformFromMatrix(t))},N.createSVGPoint=function(t,e){var r=d.createSVGPoint();return r.x=t,r.y=e,r},N.transformRect=function(t,e){var r=d.createSVGPoint();r.x=t.x,r.y=t.y;var n=r.matrixTransform(e);r.x=t.x+t.width,r.y=t.y;var a=r.matrixTransform(e);r.x=t.x+t.width,r.y=t.y+t.height;var i=r.matrixTransform(e);r.x=t.x,r.y=t.y+t.height;var s=r.matrixTransform(e),o=h(n.x,a.x,i.x,s.x),c=f(n.x,a.x,i.x,s.x),l=h(n.y,a.y,i.y,s.y),u=f(n.y,a.y,i.y,s.y);return new g.Rect(o,l,c-o,u-l)},N.transformPoint=function(t,e){return new g.Point(N.createSVGPoint(t.x,t.y).matrixTransform(e))},N.transformLine=function(t,e){return new g.Line(N.transformPoint(t.start,e),N.transformPoint(t.end,e))},N.transformPolyline=function(t,e){var r=t instanceof g.Polyline?t.points:t;N.isArray(r)||(r=[]);for(var n=[],a=0,i=r.length;a<i;a++)n[a]=N.transformPoint(r[a],e);return new g.Polyline(n)},N.styleToObject=function(t){for(var e={},r=t.split(";"),n=0;n<r.length;n++){var a=r[n].split("=");e[a[0].trim()]=a[1].trim()}return e},N.createSlicePathData=function(t,e,r,n){var a=2*v-1e-6,i=t,s=e,o=r,c=n,l=(c<o&&(l=o,o=c,c=l),c-o),u=l<v?"0":"1",h=p(o),f=x(o),d=p(c),m=x(c);return a<=l?i?"M0,"+s+"A"+s+","+s+" 0 1,1 0,"+-s+"A"+s+","+s+" 0 1,1 0,"+s+"M0,"+i+"A"+i+","+i+" 0 1,0 0,"+-i+"A"+i+","+i+" 0 1,0 0,"+i+"Z":"M0,"+s+"A"+s+","+s+" 0 1,1 0,"+-s+"A"+s+","+s+" 0 1,1 0,"+s+"Z":i?"M"+s*h+","+s*f+"A"+s+","+s+" 0 "+u+",1 "+s*d+","+s*m+"L"+i*d+","+i*m+"A"+i+","+i+" 0 "+u+",0 "+i*h+","+i*f+"Z":"M"+s*h+","+s*f+"A"+s+","+s+" 0 "+u+",1 "+s*d+","+s*m+"L0,0Z"},N.mergeAttrs=function(t,e){for(var r in e)"class"===r?t[r]=t[r]?t[r]+" "+e[r]:e[r]:"style"===r?N.isObject(t[r])&&N.isObject(e[r])?t[r]=N.mergeAttrs(t[r],e[r]):N.isObject(t[r])?t[r]=N.mergeAttrs(t[r],N.styleToObject(e[r])):N.isObject(e[r])?t[r]=N.mergeAttrs(N.styleToObject(t[r]),e[r]):t[r]=N.mergeAttrs(N.styleToObject(t[r]),N.styleToObject(e[r])):t[r]=e[r];return t},N.annotateString=function(t,e,r){e=e||[];for(var n,a,i,s=(r=r||{}).offset||0,o=[],c=[],l=0;l<t.length;l++){a=c[l]=t[l];for(var u=0;u<e.length;u++){var h=e[u],f=h.start+s,d=h.end+s;f<=l&&l<d&&(N.isObject(a)?a.attrs=N.mergeAttrs(N.mergeAttrs({},a.attrs),h.attrs):a=c[l]={t:t[l],attrs:h.attrs},r.includeAnnotationIndices&&(a.annotations||(a.annotations=[])).push(u))}(i=c[l-1])?N.isObject(a)&&N.isObject(i)?JSON.stringify(a.attrs)===JSON.stringify(i.attrs)?n.t+=a.t:(o.push(n),n=a):n=N.isObject(a)?(o.push(n),a):N.isObject(i)?(o.push(n),a):(n||"")+a:n=a}return n&&o.push(n),o},N.findAnnotationsAtIndex=function(t,e){var r=[];return t&&t.forEach(function(t){t.start<e&&e<=t.end&&r.push(t)}),r},N.findAnnotationsBetweenIndexes=function(t,e,r){var n=[];return t&&t.forEach(function(t){(e>=t.start&&e<t.end||r>t.start&&r<=t.end||t.start>=e&&t.end<r)&&n.push(t)}),n},N.shiftAnnotations=function(t,e,r){return t&&t.forEach(function(t){t.start<e&&t.end>=e?t.end+=r:t.start>=e&&(t.start+=r,t.end+=r)}),t},N.convertLineToPathData=function(t){return["M",(t=N(t)).attr("x1"),t.attr("y1"),"L",t.attr("x2"),t.attr("y2")].join(" ")},N.convertPolygonToPathData=function(t){var e=N.getPointsFromSvgNode(t);return 0===e.length?null:N.svgPointsToPath(e)+" Z"},N.convertPolylineToPathData=function(t){var e=N.getPointsFromSvgNode(t);return 0===e.length?null:N.svgPointsToPath(e)},N.svgPointsToPath=function(t){for(var e=0,r=t.length;e<r;e++)t[e]=t[e].x+" "+t[e].y;return"M "+t.join(" L")},N.getPointsFromSvgNode=function(t){var e=[],r=(t=N.toNode(t)).points;if(r)for(var n=0,a=r.numberOfItems;n<a;n++)e.push(r.getItem(n));return e},N.KAPPA=.551784,N.convertCircleToPathData=function(t){t=N(t);var e=parseFloat(t.attr("cx"))||0,r=parseFloat(t.attr("cy"))||0,n=parseFloat(t.attr("r")),a=n*N.KAPPA;return["M",e,r-n,"C",e+a,r-n,e+n,r-a,e+n,r,"C",e+n,r+a,e+a,r+n,e,r+n,"C",e-a,r+n,e-n,r+a,e-n,r,"C",e-n,r-a,e-a,r-n,e,r-n,"Z"].join(" ")},N.convertEllipseToPathData=function(t){t=N(t);var e=parseFloat(t.attr("cx"))||0,r=parseFloat(t.attr("cy"))||0,n=parseFloat(t.attr("rx")),a=parseFloat(t.attr("ry"))||n,i=n*N.KAPPA,s=a*N.KAPPA;return["M",e,r-a,"C",e+i,r-a,e+n,r-s,e+n,r,"C",e+n,r+s,e+i,r+a,e,r+a,"C",e-i,r+a,e-n,r+s,e-n,r,"C",e-n,r-s,e-i,r-a,e,r-a,"Z"].join(" ")},N.convertRectToPathData=function(t){return t=N(t),N.rectToPath({x:parseFloat(t.attr("x"))||0,y:parseFloat(t.attr("y"))||0,width:parseFloat(t.attr("width"))||0,height:parseFloat(t.attr("height"))||0,rx:parseFloat(t.attr("rx"))||0,ry:parseFloat(t.attr("ry"))||0})},N.rectToPath=function(t){var e=t.x,r=t.y,n=t.width,a=t.height,i=h(t.rx||t["top-rx"]||0,n/2),s=h(t.rx||t["bottom-rx"]||0,n/2),o=h(t.ry||t["top-ry"]||0,a/2),c=h(t.ry||t["bottom-ry"]||0,a/2);return(i||s||o||c?["M",e,r+o,"v",a-o-c,"a",s,c,0,0,0,s,c,"h",n-2*s,"a",s,c,0,0,0,s,-c,"v",-(a-c-o),"a",i,o,0,0,0,-i,-o,"h",-(n-2*i),"a",i,o,0,0,0,-i,o,"Z"]:["M",e,r,"H",e+n,"V",r+a,"H",e,"V",r,"Z"]).join(" ")},N.normalizePathData=function(){var t="\t\n\v\f\r   ᠎             　\u2028\u2029",v=new RegExp("([a-z])["+t+",]*((-?\\d*\\.?\\d*(?:e[\\-+]?\\d+)?["+t+"]*,?["+t+"]*)+)","ig"),g=new RegExp("(-?\\d*\\.?\\d*(?:e[\\-+]?\\d+)?)["+t+"]*,?["+t+"]*","ig"),e=Math,U=e.PI,Y=e.sin,X=e.cos,Z=e.tan,K=e.asin,W=e.sqrt,$=e.abs;function f(t,e,r,n,a,i){return[1/3*t+2/3*r,1/3*e+2/3*n,1/3*a+2/3*r,1/3*i+2/3*n,a,i]}function d(t){if(Array.isArray(t)&&Array.isArray(t&&t[0])||(t=function(t){if(!t)return null;var i={a:7,c:6,h:1,l:2,m:2,q:4,s:4,t:2,v:1,z:0},s=[];return String(t).replace(v,function(t,e,r){var n=[],a=e.toLowerCase();for(r.replace(g,function(t,e){e&&n.push(+e)}),"m"===a&&2<n.length&&(s.push([e].concat(n.splice(0,2))),a="l",e="m"===e?"l":"L");n.length>=i[a]&&(s.push([e].concat(n.splice(0,i[a]))),i[a]););}),s}(t)),!t||!t.length)return[["M",0,0]];for(var e,r=[],n=0,a=0,i=0,s=0,o=t.length,c=0;c<o;c++){var l=[];r.push(l);var u,h,f=t[c];if((e=f[0])!=e.toUpperCase())switch(l[0]=e.toUpperCase(),l[0]){case"A":l[1]=f[1],l[2]=f[2],l[3]=f[3],l[4]=f[4],l[5]=f[5],l[6]=+f[6]+n,l[7]=+f[7]+a;break;case"V":l[1]=+f[1]+a;break;case"H":l[1]=+f[1]+n;break;case"M":for(i=+f[1]+n,s=+f[2]+a,u=f.length,h=1;h<u;h++)l[h]=+f[h]+(h%2?n:a);break;default:for(u=f.length,h=1;h<u;h++)l[h]=+f[h]+(h%2?n:a)}else for(var d=f.length,m=0;m<d;m++)l[m]=f[m];switch(l[0]){case"Z":n=+i,a=+s;break;case"H":n=l[1];break;case"V":a=l[1];break;case"M":i=l[l.length-2],s=l[l.length-1],n=l[l.length-2],a=l[l.length-1];break;default:n=l[l.length-2],a=l[l.length-1]}}return r}function r(t){var n=d(t),e={x:0,y:0,bx:0,by:0,X:0,Y:0,qx:null,qy:null};function r(t,e,r){var n,a;if(!t)return["C",e.x,e.y,e.x,e.y,e.x,e.y];switch(t[0]in{T:1,Q:1}||(e.qx=null,e.qy=null),t[0]){case"M":e.X=t[1],e.Y=t[2];break;case"A":t=["C"].concat(function t(e,r,n,a,i,s,o,c,l,u){var h,f=120*U/180,d=U/180*(+i||0),m=[],v=function(t,e,r){return{x:t*X(r)-e*Y(r),y:t*Y(r)+e*X(r)}};if(u)A=u[0],S=u[1],P=u[2],w=u[3];else{e=(h=v(e,r,-d)).x,r=h.y;var g=(e-(c=(h=v(c,l,-d)).x))/2,p=(r-(l=h.y))/2,x=g*g/(n*n)+p*p/(a*a);1<x&&(n*=x=W(x),a*=x);var y=n*n,T=a*a,b=(s==o?-1:1)*W($((y*T-y*p*p-T*g*g)/(y*p*p+T*g*g))),P=b*n*p/a+(e+c)/2,w=b*-a*g/n+(r+l)/2,A=K(((r-w)/a).toFixed(9)),S=K(((l-w)/a).toFixed(9));(A=e<P?U-A:A)<0&&(A=2*U+A),(S=c<P?U-S:S)<0&&(S=2*U+S),S<(o&&A)&&(A-=2*U),A<(!o&&S)&&(S-=2*U)}var F=S-A;if($(F)>f){var C=S,E=c,N=l;m=t(c=P+n*X(S=A+f*(A<(o&&S)?1:-1)),l=w+a*Y(S),n,a,i,0,o,E,N,[S,C,P,w])}F=S-A;var V=X(A),L=Y(A),M=X(S),G=Y(S),O=Z(F/4),k=4/3*(n*O),I=4/3*(a*O),R=[e,r],j=[e+k*L,r-I*V],D=[c+k*G,l-I*M],B=[c,l];if(j[0]=2*R[0]-j[0],j[1]=2*R[1]-j[1],u)return[j,D,B].concat(m);for(var q=[],z=(m=[j,D,B].concat(m).join().split(",")).length,H=0;H<z;H++)q[H]=H%2?v(m[H-1],m[H],d).y:v(m[H],m[H+1],d).x;return q}.apply(0,[e.x,e.y].concat(t.slice(1))));break;case"S":a="C"===r||"S"===r?(n=2*e.x-e.bx,2*e.y-e.by):(n=e.x,e.y),t=["C",n,a].concat(t.slice(1));break;case"T":e.qy="Q"===r||"T"===r?(e.qx=2*e.x-e.qx,2*e.y-e.qy):(e.qx=e.x,e.y),t=["C"].concat(f(e.x,e.y,e.qx,e.qy,t[1],t[2]));break;case"Q":e.qx=t[1],e.qy=t[2],t=["C"].concat(f(e.x,e.y,t[1],t[2],t[3],t[4]));break;case"H":t=["L"].concat(t[1],e.y);break;case"V":t=["L"].concat(e.x,t[1])}return t}function a(t,e){if(7<t[e].length){t[e].shift();for(var r=t[e];r.length;)i[e]="A",t.splice(e++,0,["C"].concat(r.splice(0,6)));t.splice(e,1),c=n.length}}for(var i=[],s="",o="",c=n.length,l=0;l<c;l++){n[l]&&(s=n[l][0]),"C"!==s&&(i[l]=s,0<l&&(o=i[l-1])),n[l]=r(n[l],e,o),"A"!==i[l]&&"C"===s&&(i[l]="C"),a(n,l);var u=n[l],h=u.length;e.x=u[h-2],e.y=u[h-1],e.bx=parseFloat(u[h-4])||e.x,e.by=parseFloat(u[h-3])||e.y}return n[0][0]&&"M"===n[0][0]||n.unshift(["M",0,0]),n}return function(t){return r(t).join(",").split(",").join(" ")}}(),N.namespace=c,N}();

    return V;

}));
